#include "common_definitions.h"
#include "tap_definitions.h"

#include "tap.h"
#include "tap_topfield.h"


extern CHAR ib[];
extern CHAR ob[];

CHAR _strBuffer[2048];

#define C(x) 	WORD w1, w2, w3, w4, w5, w6, w7, w8, len;\
		 		LONG l1, l2, l3, l4, l5, l6, l7, l8;\
				CHAR c1, c2, c3, c4, c5, c6, c7, c8;\
				int pos = 3;\
				WORD cmd;\
				pos = GetWord(ib, pos, &cmd);\
				CreateMessage(ob, x)


#define RW(x)	pos = GetWord(ib, pos, &x)
#define RL(x)	pos = GetLong(ib, pos, &x)
#define RC(x)	pos = GetByte(ib, pos, &x)
#define RP(x)	pos = GetLong(ib, pos, &x)
#define RB(x, l) pos = GetBuffer(ib, pos, &x, &l)
#define RS()    RB(_strBuffer, len); _strBuffer[len] = '\0'


#define AW(x)	AddWordParm(ob, x)
#define AL(x)	AddLongParm(ob, x)
#define AC(x)	AddByteParm(ob, x)
#define AP(x)	AddLongParm(ob, (LONG)x)
#define AB(x, l) AddBufferParm(ob, x, l);
#define AS()    AB(_strBuffer, strlen(_strBuffer))

#define SEND()	SendBuffer()

// -- SYSTEM FUNCTION ---------------------------------------------------
void ETAP_SystemProc()
{
	int pos = 3;
	WORD cmd;
	// get command again
	pos = GetWord(ib, pos, &cmd);
	//get return parameter
	//get variable parameters
	//execute the topf command
	TAP_SystemProc();
	CreateMessage(ob, CTAP_SystemProc);
	SendBuffer();
}

void ETAP_GetState()
{
	int pos = 3;
	WORD cmd;
	LONG p1;
	LONG p2;
	// get command again
	pos = GetWord(ib, pos, &cmd);
	//get return parameter
	//get variable parameters
	//execute the topf command
	TAP_GetState(&p1, &p2);
	CreateMessage(ob, CTAP_GetState);          //TAP_Print("after CreateMessage gul=%d ", GetUsedLength(ob));
	AddLongParm(ob, p1);                       //TAP_Print("after addlong1 gul=%d ", GetUsedLength(ob));
	AddLongParm(ob, p2);                       //TAP_Print("after addlong2 gul=%d ", GetUsedLength(ob));

	//TAP_Print("created message, p1=%08lX, p2=%08lX", p1, p2);

	SendBuffer();
}

void ETAP_ExitNormal()
{
	int pos = 3;
	WORD cmd;
	// get command again
	pos = GetWord(ib, pos, &cmd);
	//get return parameter
	//get variable parameters
	//execute the topf command
	TAP_ExitNormal();
	CreateMessage(ob, CTAP_ExitNormal);
	SendBuffer();
}

void ETAP_EnterNormal()
{
	int pos = 3;
	WORD cmd;
	// get command again
	pos = GetWord(ib, pos, &cmd);
	//get return parameter
	//get variable parameters
	//execute the topf command
	TAP_EnterNormal();
	CreateMessage(ob, CTAP_EnterNormal);
	SendBuffer();
}

void ETAP_Exit()
{
	int pos = 3;
	WORD cmd;
	// get command again
	pos = GetWord(ib, pos, &cmd);
	//get return parameter
	//get variable parameters
	//execute the topf command
	TAP_Exit();
	CreateMessage(ob, CTAP_Exit);
	SendBuffer();
}


void ETAP_KbHit()
{
	int pos = 3;
	WORD cmd;
	CHAR p1;
	// get command again
	pos = GetWord(ib, pos, &cmd);
	//get return parameter
	//get variable parameters
	//execute the topf command
	p1 = TAP_KbHit();
	CreateMessage(ob, CTAP_KbHit);
	AddByteParm(ob, p1);
	SendBuffer();
}

void ETAP_GetCh()
{
	C(CTAP_GetCh);
	//CANNOT USE 
	SEND();
}

void ETAP_PutCh()
{
	C(CTAP_PutCh);
	//CANNOT USE 
	SEND();
}

void ETAP_Print()
{
	C(CTAP_Print);
	//CANNOT USE 
	SEND();
}


// -- COMMON FUNCTION ---------------------------------------------------
//extern	int	    (*TAP_SetSoundLevel)(byte soundLevel);
void ETAP_SetSoundLevel()
{
	C(CTAP_SetSoundLevel);
	RC(c1);
	w1 = TAP_SetSoundLevel(c1);
	AW(w1);
	SEND();
}

//extern	int	    (*TAP_GetTime)(word *mjd, byte *hour, byte *min, byte *sec);
void ETAP_GetTime()
{
	word ww;
	C(CTAP_GetTime);
	w1 = TAP_GetTime(&ww, &c1, &c2, &c3);
	w1 = ww;
	AW(w1);
	AW(w2);
	AC(c1);
	AC(c2);
	AC(c3);
	SEND();
}

//extern	void	(*TAP_MemInfo)(dword *heapSize, dword *freeHeapSize, dword *availHeapSize);
void ETAP_MemInfo()
{
	C(CTAP_MemInfo);
	TAP_MemInfo(&l1, &l2, &l3);
	AL(l1);
	AL(l2);
	AL(l3);
	SEND();
}

//extern	void*	(*TAP_MemAlloc)(dword size);
void ETAP_MemAlloc()
{
	C(CTAP_MemAlloc);
	RL(l1);
	l2 = (LONG)TAP_MemAlloc(l1);
	AL(l2);
	SEND();
}

//extern	int	    (*TAP_MemFree)(const void *addr);
void ETAP_MemFree()
{
	C(CTAP_MemFree);
	RL(l1);
	w1 = TAP_MemFree((void*)l1);
	AW(w1);
	SEND();
}

//extern	dword	(*TAP_GetTick)(void);
void ETAP_GetTick()
{
	C(CTAP_GetTick);
	l1 = TAP_GetTick();
	AL(l1);
	SEND();
}

//extern	void	(*TAP_Delay)(dword dm10);
void ETAP_Delay()
{
	C(CTAP_Delay);
	RL(l1);
	TAP_Delay(l1);
	SEND();
}

//extern	int	    (*TAP_ExtractMjd)(word mjd, word *year, byte *month, byte *day, byte *weekDay);
void ETAP_ExtractMjd()
{
	word ww;
	C(CTAP_ExtractMjd);
	RW(w1);
	w2 = TAP_ExtractMjd(w1, &ww, &c1, &c2, &c3);
	w3 = ww;
	AW(w2);
	AW(w3);
	AC(c1);
	AC(c2);
	AC(c3);
	SEND();
}

//extern	int	    (*TAP_MakeMjd)(word year, byte month, byte day);
void ETAP_MakeMjd()
{
	C(CTAP_MakeMjd);
	RW(w1);
	RC(c1);
	RC(c2);
	w2 = TAP_MakeMjd(w1, c1, c2);
	AW(w2);
	SEND();
}



//extern	long	(*TAP_Sin)( long mul, long th );
void ETAP_Sin()
{
	C(CTAP_Sin);
	RL(l1);
	RL(l2);

	l3 = TAP_Sin(l1, l2);
	AL(l3);

	SEND();
}

//extern	long	(*TAP_Cos)( long mul, long th );
void ETAP_Cos()
{
	C(CTAP_Cos);
	RL(l1);
	RL(l2);

	l3 = TAP_Cos(l1, l2);
	AL(l3);

	SEND();
}

//extern	void	(*TAP_SPrint)(void *s, const void *fmt, ...);
void ETAP_SPrint()
{
	C(CTAP_SPrint);
	// NOT IMPLEMENTED
	SEND();
}

//extern	int 	(*TAP_GetSignalLevel)(void);
void ETAP_GetSignalLevel()
{
	C(CTAP_GetSignalLevel);
	w1 = TAP_GetSignalLevel();
	AW(w1);
	SEND();
}

//extern	int 	(*TAP_GetSignalQuality)(void);
void ETAP_GetSignalQuality()
{
	C(CTAP_GetSignalQuality);
	w1 = TAP_GetSignalQuality();
	AW(w1);
	SEND();

}

//extern  int 	(*TAP_SetInfoboxTime)( int sec );
void ETAP_SetInfoboxTime()
{
	C(CTAP_SetInfoboxTime);
	RW(w1);
	w2 = TAP_SetInfoboxTime(w1);
	AW(w2);
	SEND();
}

//extern  int		(*TAP_PlayPCM)( void *pcmdata, int size, int freq, void (*Callback)(void) );
void ETAP_PlayPCM()
{
	C(CTAP_PlayPCM);
	// NOT IMPLEMENTED
	SEND();
}

//extern	int 	(*TAP_CaptureScreen)( int mainSub, TYPE_VideoBank *videoBank );
void ETAP_CaptureScreen()
{
	C(CTAP_CaptureScreen);
	// NOT IMPLEMENTED
	SEND();
}


//extern	int 	(*TAP_SetSystemVar)( int varId, int value );
void ETAP_SetSystemVar()
{
	C(CTAP_SetSystemVar);
	RW(w1);
	RW(w2);
	w3 = TAP_SetSystemVar(w1, w2);
	AW(w3);
	SEND();
}

//extern	int 	(*TAP_GetSystemVar)( int varId );
void ETAP_GetSystemVar()
{
	C(CTAP_GetSystemVar);
	RW(w1);
	w2 = TAP_GetSystemVar(w1);
	AW(w2);
	SEND();
}

//extern	int 	(*TAP_WriteSystemVar)( void );
void ETAP_WriteSystemVar()
{
	C(CTAP_WriteSystemVar);
	w1 = TAP_WriteSystemVar();
	AW(w1);
	SEND();
}

//extern	void	(*TAP_GenerateEvent)(  word evtCode, dword param1, dword param2 );
void ETAP_GenerateEvent()
{
	C(CTAP_GenerateEvent);
	RW(w1);
	RL(l1);
	RL(l2);
	TAP_GenerateEvent(w1, l1, l2);
	SEND();
}


// -- OSD FUNCTION ---------------------------------------------------
//extern	int	(*TAP_Osd_Create)( dword x, dword y, dword w, dword h, byte lutIdx, int flag );
void ETAP_Osd_Create()
{
	int pos = 3;
	WORD cmd;
	LONG x, y, w, h;
	CHAR lutIdx;
	WORD flag;
	WORD res;
	// get command again
	pos = GetWord(ib, pos, &cmd);
	pos = GetLong(ib, pos, &x);
	pos = GetLong(ib, pos, &y);
	pos = GetLong(ib, pos, &w);
	pos = GetLong(ib, pos, &h);
	pos = GetByte(ib, pos, &lutIdx);
	pos = GetWord(ib, pos, &flag);
	//get return parameter
	//get variable parameters
	//execute the topf command
	res = TAP_Osd_Create(x, y, w, h, lutIdx, flag);
	CreateMessage(ob, CTAP_Osd_Create);
	AddWordParm(ob, res);
	SendBuffer();
}

//extern	int	(*TAP_Osd_Delete)(word rgn);
void ETAP_Osd_Delete()
{
	int pos = 3;
	WORD cmd;
	WORD rgn;
	WORD res;
	// get command again
	pos = GetWord(ib, pos, &cmd);
	pos = GetWord(ib, pos, &rgn);
	//get return parameter
	//get variable parameters
	//execute the topf command
	res = TAP_Osd_Delete(rgn);
	CreateMessage(ob, CTAP_Osd_Delete);
	AddWordParm(ob, res);
	SendBuffer();
}






//extern	int	(*TAP_Osd_Move)(word rgn, dword x, dword y);
void ETAP_Osd_Move()
{
	C(CTAP_Osd_Move);
	RW(w1);
	RL(l1);
	RL(l2);

	w2 = TAP_Osd_Move(w1, l1, l2);
	AW(w2);

	SEND();
}

//extern	int	(*TAP_Osd_FillBox)(word rgn, dword x, dword y, dword w, dword h, dword color);
void ETAP_Osd_FillBox()
{
	C(CTAP_Osd_FillBox);
	RW(w1);
	RL(l1);
	RL(l2);
	RL(l3);
	RL(l4);
	RL(l5);

	w2 = TAP_Osd_FillBox(w1, l1, l2, l3, l4, l5);
	AW(w2);

	SEND();
}

//extern	int	(*TAP_Osd_PutBox)(word rgn, dword x, dword y, dword w, dword h, const void *data, bool sprite, byte dataFormat );
void ETAP_Osd_PutBox()
{
	C(CTAP_Osd_PutBox);
	RW(w1);
	RL(l1);
	RL(l2);
	RL(l3);
	RL(l4);
	RL(l5);
	RC(c1);
	RC(c2);

	w2 = TAP_Osd_PutBox(w1, l1, l2, l3, l4, (void*)l5, c1, c2);

	AW(w2);

	SEND();
}

//extern	int	(*TAP_Osd_GetBox)(word rgn, dword x, dword y, dword w, dword h, void *data);
void ETAP_Osd_GetBox()
{
	C(CTAP_Osd_GetBox);
	RW(w1);
	RL(l1);
	RL(l2);
	RL(l3);
	RL(l4);
	RL(l5);

	w2 = TAP_Osd_GetBox(w1, l1, l2, l3, l4, (void*)l5);
	AW(w2);

	SEND();
}

//extern	int	(*TAP_Osd_SetLut)(byte lutIdx, byte lut[][4] );
void ETAP_Osd_SetLut()
{
	C(CTAP_Osd_SetLut);
	// NOT IMPLEMENTED
	SEND();
}
//extern	int	(*TAP_Osd_Ctrl)(word rgn, dword ctrl);
void ETAP_Osd_Ctrl()
{
	C(CTAP_Osd_Ctrl);
	// NOT IMPLEMENTED
	SEND();
}

//extern	int	(*TAP_Osd_SetTransparency)( word rgn, char rt);
void ETAP_Osd_SetTransparency()
{
	C(CTAP_Osd_SetTransparency);
	RW(w1);
	RC(c1);

	w2 = TAP_Osd_SetTransparency(w1, c1);
	AW(w2);

	SEND();
}


//extern	int	(*TAP_Osd_Draw3dBox)( word rgn, dword x, dword y, dword w, dword h, dword c1, dword c2 );
void ETAP_Osd_Draw3dBox()
{
	C(CTAP_Osd_Draw3dBox);
	RW(w1);
	RL(l1);
	RL(l2);
	RL(l3);
	RL(l4);
	RL(l5);
	RL(l6);

	w2 = TAP_Osd_Draw3dBox(w1, l1, l2, l3, l4, l5, l6);
	AW(w2);

	SEND();
}

//extern	int	(*TAP_Osd_Draw3dBoxFill)( word rgn, dword x, dword y, dword w, dword h, dword c1, dword c2, dword fc );
void ETAP_Osd_Draw3dBoxFill()
{
	C(CTAP_Osd_Draw3dBoxFill);
	RW(w1);
	RL(l1);
	RL(l2);
	RL(l3);
	RL(l4);
	RL(l5);
	RL(l6);
	RL(l7);

	w2 = TAP_Osd_Draw3dBoxFill(w1, l1, l2, l3, l4, l5, l6, l7);
	AW(w2);

	SEND();
}

//extern	int	(*TAP_Osd_DrawRectangle)(word rgn, dword x, dword y, dword w, dword h, dword t, dword color);
void ETAP_Osd_DrawRectangle()
{
	C(CTAP_Osd_DrawRectangle);
	RW(w1);
	RL(l1);
	RL(l2);
	RL(l3);
	RL(l4);
	RL(l5);
	RL(l6);

	w2 = TAP_Osd_DrawRectangle(w1, l1, l2, l3, l4, l5, l6);
	AW(w2);

	SEND();
}

//extern	int	(*TAP_Osd_DrawPixmap)(word rgn, dword x, dword y, dword w, dword h, void *pixmap, bool sprite, byte dataFormat );
void ETAP_Osd_DrawPixmap()
{
	C(CTAP_Osd_DrawPixmap);
	// NOT IMPLEMENTED
	SEND();
}

//extern  int (*TAP_Osd_Zoom)( int xzoom, int yzoom );
void ETAP_Osd_Zoom()
{
	C(CTAP_Osd_Zoom);
	RW(w1);
	RW(w2);

	w3 = TAP_Osd_Zoom(w1, w2);

	AW(w3);

	SEND();
}

//extern  int (*TAP_Osd_GetBaseInfo)( TYPE_OsdBaseInfo *info );
void ETAP_Osd_GetBaseInfo()
{
	C(CTAP_Osd_GetBaseInfo);
	// NOT IMPLEMENTED
	SEND();
}

//extern	int (*TAP_Osd_Copy)(word srcRgnNum, word dstRgnNum, dword srcX, dword srcY, dword w, dword h, dword dstX, dword dstY,  bool sprite);
void ETAP_Osd_Copy()
{
	C(CTAP_Osd_Copy);
	RW(w1);
	RW(w2);
	RL(l1);
	RL(l2);
	RL(l3);
	RL(l4);
	RL(l5);
	RL(l6);
	RC(c1);

	w3 = TAP_Osd_Copy(w1, w2, l1, l2, l3, l4, l5, l6, c1);
	AW(w3);

	SEND();
}

//extern  int	TAP_Osd_PutGd(word rgn, int x, int y, TYPE_GrData * gd, bool sprite);
void ETAP_Osd_PutGd()
{
	C(CTAP_Osd_PutGd);
	// NOT IMPLEMENTED
	SEND();
}


//extern	byte*	(*TAP_Osd_SaveBox)( word rgn, dword x, dword y, dword w, dword h );
void ETAP_Osd_SaveBox()
{
	C(CTAP_Osd_SaveBox);
	// NOT IMPLEMENTED
	SEND();
}

//extern	void	(*TAP_Osd_RestoreBox)( word rgn, dword x, dword y, dword w, dword h, void *data );
void ETAP_Osd_RestoreBox()
{
	C(CTAP_Osd_RestoreBox);
	// NOT IMPLEMENTED
	SEND();
}


//extern	int	(*TAP_Osd_GetPixel)( word rgn, dword x, dword y, void *pix );
void ETAP_Osd_GetPixel()
{
	C(CTAP_Osd_GetPixel);
	RW(w1);
	RL(l1);
	RL(l2);

	w2 = TAP_Osd_GetPixel(w1, l1, l2, &c1);
	AW(w2);
	AC(c1);

	SEND();
}

//extern	int	(*TAP_Osd_PutPixel)( word rgn, dword x, dword y, dword pix );
void ETAP_Osd_PutPixel()
{
	int pos = 3;
	WORD cmd;
	LONG x, y, pix;
	WORD rgn;
	WORD res;
	// get command again
	pos = GetWord(ib, pos, &cmd);
	pos = GetWord(ib, pos, &rgn);
	pos = GetLong(ib, pos, &x);
	pos = GetLong(ib, pos, &y);
	pos = GetLong(ib, pos, &pix);
	//get return parameter
	//get variable parameters
	//execute the topf command
	res = TAP_Osd_PutPixel(rgn, x, y, pix);
	CreateMessage(ob, CTAP_Osd_PutPixel);
	AddWordParm(ob, res);
	SendBuffer();
}


// -- HDD FUNCTION ---------------------------------------------------

//extern	TYPE_File*	(*TAP_Hdd_Fopen)( char *name );
void ETAP_Hdd_Fopen()
{
	C(CTAP_Hdd_Fopen);
	RS();

	l1 = (LONG)TAP_Hdd_Fopen(_strBuffer);
	AL(l1);
	
	SEND();
}

//extern	dword		(*TAP_Hdd_Fread)( void *buf, dword blksize, dword blk, TYPE_File *file );
void ETAP_Hdd_Fread()
{
	C(CTAP_Hdd_Fread);
	// NOT IMPLEMENTED
	SEND();
}

//extern	dword		(*TAP_Hdd_Fwrite)( void *buf, dword blksize, dword blk, TYPE_File *file );
void ETAP_Hdd_Fwrite()
{
	C(CTAP_Hdd_Fwrite);
	// NOT IMPLEMENTED
	SEND();
}

//extern	void		(*TAP_Hdd_Fclose)( TYPE_File *file );
void ETAP_Hdd_Fclose()
{
	C(CTAP_Hdd_Fclose);
	// NOT IMPLEMENTED
	SEND();
}

//extern	dword		(*TAP_Hdd_FindFirst)( TYPE_File *file );
void ETAP_Hdd_FindFirst()
{
	C(CTAP_Hdd_FindFirst);
	// NOT IMPLEMENTED
	SEND();
}

//extern	dword		(*TAP_Hdd_FindNext)( TYPE_File *file );
void ETAP_Hdd_FindNext()
{
	C(CTAP_Hdd_FindNext);
	// NOT IMPLEMENTED
	SEND();
}

//extern	dword		(*TAP_Hdd_Fseek)( TYPE_File *file, long pos, long where );
void ETAP_Hdd_Fseek()
{
	C(CTAP_Hdd_Fseek);
	// NOT IMPLEMENTED
	SEND();
}

//extern	dword		(*TAP_Hdd_Flen)( TYPE_File *file );
void ETAP_Hdd_Flen()
{
	C(CTAP_Hdd_Flen);
	// NOT IMPLEMENTED
	SEND();
}

//extern	dword		(*TAP_Hdd_Ftell)( TYPE_File *file );
void ETAP_Hdd_Ftell()
{
	C(CTAP_Hdd_Ftell);
	// NOT IMPLEMENTED
	SEND();
}

//extern	dword		(*TAP_Hdd_TotalSize)( void );
void ETAP_Hdd_TotalSize()
{
	C(CTAP_Hdd_TotalSize);
	// NOT IMPLEMENTED
	SEND();
}


//extern	dword		(*TAP_Hdd_FreeSize)( void );
void ETAP_Hdd_FreeSize()
{
	C(CTAP_Hdd_FreeSize);
	// NOT IMPLEMENTED
	SEND();
}

//extern	word		(*TAP_Hdd_Delete)( char *name );
void ETAP_Hdd_Delete()
{
	C(CTAP_Hdd_Delete);
	// NOT IMPLEMENTED
	SEND();
}

//extern	bool		(*TAP_Hdd_Exist)( char *name );
void ETAP_Hdd_Exist()
{
	C(CTAP_Hdd_Exist);
	// NOT IMPLEMENTED
	SEND();
}

//extern	dword		(*TAP_Hdd_Create)( char *name, byte attr );
void ETAP_Hdd_Create()
{
	C(CTAP_Hdd_Create);
	// NOT IMPLEMENTED
	SEND();
}

//extern	word		(*TAP_Hdd_ChangeDir)( char *dir );
void ETAP_Hdd_ChangeDir()
{
	C(CTAP_Hdd_ChangeDir);
	// NOT IMPLEMENTED
	SEND();
}


//extern	int			(*TAP_Hdd_PlayTs)( char *name );
void ETAP_Hdd_PlayTs()
{
	C(CTAP_Hdd_PlayTs);
	// NOT IMPLEMENTED
	SEND();
}

//extern	int			(*TAP_Hdd_StopTs)( void);
void ETAP_Hdd_StopTs()
{
	C(CTAP_Hdd_StopTs);
	// NOT IMPLEMENTED
	SEND();
}

//extern	int			(*TAP_Hdd_PlayMp3)( char *name );
void ETAP_Hdd_PlayMp3()
{
	C(CTAP_Hdd_PlayMp3);
	// NOT IMPLEMENTED
	SEND();
}

//extern	int			(*TAP_Hdd_StopMp3)( void );
void ETAP_Hdd_StopMp3()
{
	C(CTAP_Hdd_StopMp3);
	// NOT IMPLEMENTED
	SEND();
}

//extern	bool		(*TAP_Hdd_Rename)(   	char *oldName, char *newName );
void ETAP_Hdd_Rename()
{
	C(CTAP_Hdd_Rename);
	// NOT IMPLEMENTED
	SEND();
}



// -- STRING FUNCTION ---------------------

//extern  int	(*TAP_Osd_PutS)(word rgn, dword x, dword y, dword maxX, const char * str, word fcolor, word bcolor, byte fntType, byte fntSize, byte bDot, byte align);
void ETAP_Osd_PutS()
{
	C(CTAP_Osd_PutS);
	RW(w1);
	RL(l1);
	RL(l2);
	RL(l3);
	RS();
	RW(w2);
	RW(w3);
	RC(c1);
	RC(c2);
	RC(c3);
	RC(c4);
	w4 = TAP_Osd_PutS(w1, l1, l2, l3, _strBuffer, w2, w3, c1, c2, c3, c4);
	AW(w4);
	SEND();
}

//extern	int	(*TAP_Osd_GetW)( const char *str, byte fntType, byte fntSize );
void ETAP_Osd_GetW()
{
	C(CTAP_Osd_GetW);
	RS();
	RC(c1);
	RC(c2);
	
	w1 = TAP_Osd_GetW(_strBuffer, c1, c2);
	RW(w1);

	SEND();
}

//extern  int	(*TAP_Osd_PutString)(word rgn, dword x, dword y, dword maxX, const char * str, word fcolor, word bcolor, byte fntType, byte fntSize, byte nextLine);
void ETAP_Osd_PutString()
{
	C(CTAP_Osd_PutString);
	RW(w1);
	RL(l1);
	RL(l2);
	RL(l3);
	RS();
	RW(w2);
	RW(w3);
	RC(c1);
	RC(c2);
	RC(c3);
	//TAP_Print("w1:%d,l1:%ld,l2:%d,l3:%d,str:%s,len:%d,w2:%d,w3:%d,c1:%d,c2:%d,c3:%d",w1,l1,l2,l3,str,len,w2,w3,c1,c2,c3);
	w4 = TAP_Osd_PutString(w1, l1, l2, l3, _strBuffer, w2, w3, c1, c2, c3);
	AW(w4);
	SEND();
}

//extern  int	(*TAP_Osd_DrawString)(const char * str, dword dstWidth, word color, byte * dest, dword maxWidth, byte fntType, byte fntSize);
void ETAP_Osd_DrawString()
{
	C(CTAP_Osd_DrawString);
	RS();
	RL(l1);
	RW(w1);
	RL(l2);
	RL(l3);
	RC(c1);
	RC(c2);

	w2 = TAP_Osd_DrawString(_strBuffer, l1, w1, (CHAR*)l2, l3, c1, c2);
	AW(w2);

	SEND();
}

//extern  int	(*TAP_Osd_PutStringAf)(word rgn, dword x, dword y, dword maxX, const char * str, word fcolor, word bcolor, byte fntType, byte fntSize, byte nextLine);
void ETAP_Osd_PutStringAf()
{
	C(CTAP_Osd_PutStringAf);
	RW(w1);
	RL(l1);
	RL(l2);
	RL(l3);
	RS();
	RW(w2);
	RW(w3);
	RC(c1);
	RC(c2);
	RC(c3);
	//TAP_Print("w1:%d,l1:%ld,l2:%d,l3:%d,str:%s,len:%d,w2:%d,w3:%d,c1:%d,c2:%d,c3:%d",w1,l1,l2,l3,str,len,w2,w3,c1,c2,c3);
	w4 = TAP_Osd_PutStringAf(w1, l1, l2, l3, _strBuffer, w2, w3, c1, c2, c3);
	AW(w4);

	SEND();
}


// -- WINDOW FUNCTION ---------------------------------------------------

//extern	void	(*TAP_Win_SetTitle)( TYPE_Window *win, const char *str, byte fntType, byte fntSize );
void ETAP_Win_SetTitle()
{
	C(CTAP_Win_SetTitle);
	RL(l1);
	RS();
	RC(c1);
	RC(c2);

	TAP_Win_SetTitle((TYPE_Window *)l1, _strBuffer, c1, c2);

	SEND();
}

//extern  void	(*TAP_Win_SetColor)(TYPE_Window * win, word titleBack, word titleText, word bodyBack, word bodyText, word border, word shadow, word dark, word light);
void ETAP_Win_SetColor()
{
	C(CTAP_Win_SetColor);
	RL(l1);
	RW(w1);
	RW(w2);
	RW(w3);
	RW(w4);
	RW(w5);
	RW(w6);
	RW(w7);
	RW(w8);

	TAP_Win_SetColor((TYPE_Window*)l1, w1, w2, w3, w4, w5, w6, w7, w8);

	SEND();
}

//extern	void	(*TAP_Win_SetDefaultColor)( TYPE_Window *win );
void ETAP_Win_SetDefaultColor()
{
	C(CTAP_Win_SetDefaultColor);
	RL(l1);

	TAP_Win_SetDefaultColor((TYPE_Window*)l1);

	SEND();
}

//extern	void	(*TAP_Win_Draw) 	( TYPE_Window *win );
void ETAP_Win_Draw()
{
	C(CTAP_Win_Draw);
	RL(l1);

	TAP_Win_Draw((TYPE_Window*)l1);

	SEND();
}

//extern	void	(*TAP_Win_Create)	( TYPE_Window *win, word rgn, dword x, dword y, dword w, dword h, byte save, byte bScr );
void ETAP_Win_Create()
{
	C(CTAP_Win_Create);
	RL(l1);
	RW(w1);
	RL(l2);
	RL(l3);
	RL(l4);
	RL(l5);
	RC(c1);
	RC(c2);

	TAP_Win_Create((TYPE_Window*)l1, w1, l2, l3, l4, l5, c1, c2);

	SEND();
}

//extern	dword	(*TAP_Win_Delete)	( TYPE_Window *win );
void ETAP_Win_Delete()
{
	C(CTAP_Win_Delete);
	RL(l1);

	TAP_Win_Delete((TYPE_Window*)l1);

	SEND();
}

//extern	void	(*TAP_Win_SetFont)	( TYPE_Window *win, byte fntType, byte fntSize );
void ETAP_Win_SetFont()
{
	C(CTAP_Win_SetFont);
	RL(l1);
	RC(c1);
	RC(c2);

	TAP_Win_SetFont((TYPE_Window*)l1, c1, c2);

	SEND();
}

//extern	void	(*TAP_Win_AddItem)	( TYPE_Window *win, char *str );
void ETAP_Win_AddItem()
{
	C(CTAP_Win_AddItem);
	RL(l1);
	RS();

	TAP_Win_AddItem((TYPE_Window*)l1, _strBuffer);

	SEND();
}

//extern	dword	(*TAP_Win_GetSelection)( TYPE_Window *win );
void ETAP_Win_GetSelection()
{
	C(CTAP_Win_GetSelection);
	RL(l1);

	l2 = TAP_Win_GetSelection((TYPE_Window*)l1);
	AL(l2);

	SEND();
}

//extern	void	(*TAP_Win_SetSelection)( TYPE_Window *win, dword pos );
void ETAP_Win_SetSelection()
{
	C(CTAP_Win_SetSelection);
	RL(l1);
	RL(l2);

	TAP_Win_SetSelection((TYPE_Window*)l1, l2);

	SEND();
}

//extern	void	(*TAP_Win_Action)	( TYPE_Window *win, dword key );
void ETAP_Win_Action()
{
	C(CTAP_Win_Action);
	RL(l1);
	RL(l2);

	TAP_Win_Action((TYPE_Window*)l1, l2);

	SEND();
}


// ---------------------------------------------------------------------
//

//extern	int (*TAP_Channel_GetTotalNum)( int *nTvSvc, int *nRadioSvc );
void ETAP_Channel_GetTotalNum()
{
	C(CTAP_Channel_GetTotalNum);

	w1 = TAP_Channel_GetTotalNum(&w2, &w3);
	AW(w1);
	AW(w2);
	AW(w3);

	SEND();
}

//extern	int (*TAP_Channel_GetFirstInfo)( int svcType, TYPE_TapChInfo *chInfo );
void ETAP_Channel_GetFirstInfo()
{
	C(CTAP_Channel_GetFirstInfo);
	// NOT IMPLEMENTED
	SEND();
}

//extern	int (*TAP_Channel_GetNextInfo)( TYPE_TapChInfo *chInfo );
void ETAP_Channel_GetNextInfo()
{
	C(CTAP_Channel_GetNextInfo);
	// NOT IMPLEMENTED
	SEND();
}

//extern	int (*TAP_Channel_GetInfo)( int svcType, int svcNum, TYPE_TapChInfo *chInfo );
void ETAP_Channel_GetInfo()
{
	C(CTAP_Channel_GetInfo);
	// NOT IMPLEMENTED
	SEND();
}

//extern	int (*TAP_Channel_GetCurrent)( int *tvRadio, int *svcNum );
void ETAP_Channel_GetCurrent()
{
	C(CTAP_Channel_GetCurrent);
	w1 = TAP_Channel_GetCurrent(&w2, &w3);
	AW(w1);
	AW(w2);
	AW(w3);

	SEND();
}

//extern  int (*TAP_Channel_Start)( int mainSub, int svcType, int chNum );
void ETAP_Channel_Start()
{
	C(CTAP_Channel_Start);
	RW(w1);
	RW(w2);
	RW(w3);

	w4 = TAP_Channel_Start(w1, w2, w3);
	AW(w4);

	SEND();
}

//extern  int (*TAP_Channel_Scale)( int mainSub, long x, long y, long w, long h, bool anim );
void ETAP_Channel_Scale()
{
	C(CTAP_Channel_Scale);
	RW(w1);
	RL(l1);
	RL(l2);
	RL(l3);
	RL(l4);
	RC(c1);

	w2 = TAP_Channel_Scale(w1, l1, l2, l3, l4, c1);
	AW(w2);

	SEND();
}

//extern  int (*TAP_Channel_IsPlayable)( int mainSub, int svcType, int chNum );
void ETAP_Channel_IsPlayable()
{
	C(CTAP_Channel_IsPlayable);
	RW(w1);
	RW(w2);
	RW(w3);

	w4 = TAP_Channel_IsPlayable(w1, w2, w3);
	AW(w4);

	SEND();
}

//extern  int (*TAP_Channel_Move)( int mainSub, int dir );
void ETAP_Channel_Move()
{
	C(CTAP_Channel_Move);
	RW(w1);
	RW(w2);

	w3 = TAP_Channel_Move(w1, w2);
	AW(w3);

	SEND();
}

//extern  int (*TAP_Channel_Stop)( int mainSub );
void ETAP_Channel_Stop()
{
	C(CTAP_Channel_Stop);
	RW(w1);

	w2 = TAP_Channel_Stop(w1);
	AW(w2);

	SEND();
}

//extern  int (*TAP_Channel_GetTotalAudioTrack)( void );
void ETAP_Channel_GetTotalAudioTrack()
{
	C(CTAP_Channel_GetTotalAudioTrack);

	w1 = TAP_Channel_GetTotalAudioTrack();
	AW(w1);

	SEND();
}

//extern  char *(*TAP_Channel_GetAudioTrackName)( int trkNum, char *trkName );
void ETAP_Channel_GetAudioTrackName()
{
	C(CTAP_Channel_GetAudioTrackName);
	RW(w1);

	TAP_Channel_GetAudioTrackName(w1, (char *)&_strBuffer);
	AS();

	SEND();
}

//extern  int (*TAP_Channel_SetAudioTrack)( int trkNum );
void ETAP_Channel_SetAudioTrack()
{
	C(CTAP_Channel_SetAudioTrack);
	RW(w1);

	w2 = TAP_Channel_SetAudioTrack(w1);
	AW(w2);

	SEND();
}

//extern  int (*TAP_Channel_GetTotalSubtitleTrack)( void );
void ETAP_Channel_GetTotalSubtitleTrack()
{
	C(CTAP_Channel_GetTotalSubtitleTrack);

	w1 = TAP_Channel_GetTotalSubtitleTrack();
	AW(w1);

	SEND();
}

//extern  char *(*TAP_Channel_GetSubtitleTrackName)( int trkNum, char *trkName );
void ETAP_Channel_GetSubtitleTrackName()
{
	C(CTAP_Channel_GetSubtitleTrackName);
	RW(w1);

	TAP_Channel_GetSubtitleTrackName(w1, (char *)&_strBuffer);
	AS();

	SEND();
}

//extern  int (*TAP_Channel_SetSubtitleTrack)( int trkNum );
void ETAP_Channel_SetSubtitleTrack()
{
	C(CTAP_Channel_SetSubtitleTrack);
	RW(w1);

	w2 = TAP_Channel_SetSubtitleTrack(w1);
	AW(w2);

	SEND();
}


//extern	TYPE_TapEvent*	(*TAP_GetEvent)( int svcType, int svcNum, int *eventNum );
void ETAP_GetEvent()
{
	C(CTAP_GetEvent);
	RW(w1);
	RW(w2);
	
	l1 = (LONG)TAP_GetEvent(w1, w2, &w3);
	AL(l1);
	AW(w3);

	SEND();
}

//extern	TYPE_TapEvent*	(*TAP_GetCurrentEvent)( int svcType, int svcNum );
void ETAP_GetCurrentEvent()
{
	C(CTAP_GetCurrentEvent);
	RW(w1);
	RW(w2);
	
	l1 = (LONG)TAP_GetCurrentEvent(w1, w2);
	AL(l1);

	SEND();
}


// --- USB FUNCTIONS ---------------------------------------------------

void ETAP_Usb_Read()
{
	// NOT IMPLEMENTED
}

void ETAP_Usb_Write()
{
		// NOT IMPLEMENTED
}

void ETAP_Usb_PacketRead()
{
		// NOT IMPLEMENTED
}

void ETAP_Usb_PacketWrite()
{
		// NOT IMPLEMENTED
}

void ETAP_Usb_Cancel()
{
		// NOT IMPLEMENTED
}


// --- TIMER FUNCTIONS ---------------------------------------------------


//extern int  (*TAP_Timer_GetTotalNum)( void );
void ETAP_Timer_GetTotalNum()
{
	C(CTAP_Timer_GetTotalNum);

	w1 = TAP_Timer_GetTotalNum();
	AW(w1);

	SEND();
}

//extern bool (*TAP_Timer_GetInfo)( int entryNum, TYPE_TimerInfo *info );
void ETAP_Timer_GetInfo()
{
	TYPE_TimerInfo info;
	C(CTAP_Timer_GetInfo);
	RW(w1);

	c1 = TAP_Timer_GetInfo(w1, &info);
	AC(c1);
	AB(info, sizeof(TYPE_TimerInfo));

	SEND();
}

//extern int (*TAP_Timer_Add)( TYPE_TimerInfo *info );
void ETAP_Timer_Add()
{
	TYPE_TimerInfo info;
	C(CTAP_Timer_Add);
	RB(info, len);

	w1 = TAP_Timer_Add(&info);
	AW(w1);

	SEND();
}

//extern int (*TAP_Timer_Modify)( int entryNum, TYPE_TimerInfo *info );
void ETAP_Timer_Modify()
{
	TYPE_TimerInfo info;
	C(CTAP_Timer_Modify);
	RB(info, len);

	w1 = TAP_Timer_Add(&info);
	AW(w1);


	SEND();
}

//extern bool (*TAP_Timer_Delete)( int entryNum );
void ETAP_Timer_Delete()
{
	C(CTAP_Timer_Delete);
	RW(w1);

	c1 = TAP_Timer_Delete(w1);
	AC(c1);

	SEND();
}


// ---------------------------------------------------------------------


// ---------------------- DEBUG CONTROL -----------------------

// retrieves the buffer from pointer l1, with len w1
void ETAP_Debug_BufferT2P()
{
	C(CTAP_Debug_BufferT2P);
	RL(l1);
	RW(w1);

	AB((CHAR*)l1, w1);

	SEND();
}

void ETAP_Debug_BufferP2T()
{
	CHAR *p;
	C(CTAP_Debug_BufferP2T);
	RL(l1);

	pos = GetBuffer(ib, pos, (CHAR*)l1, &len);

	SEND();
}

