// -- SYSTEM FUNCTION ---------------------------------------------------
ETAP_SystemProc();
ETAP_GetState();
ETAP_ExitNormal();
ETAP_EnterNormal();
ETAP_Exit();

ETAP_KbHit();
ETAP_GetCh();
ETAP_PutCh();
ETAP_Print();

// -- COMMON FUNCTION ---------------------------------------------------
ETAP_SetSoundLevel();
ETAP_GetTime();
ETAP_MemInfo();
ETAP_MemAlloc();
ETAP_MemFree();
ETAP_GetTick();
ETAP_Delay();
ETAP_ExtractMjd();
ETAP_MakeMjd();
ETAP_Sin();
ETAP_Cos();
ETAP_SPr();
ETAP_GetSignalLevel();
ETAP_GetSignalQuality();
ETAP_SetInfoboxTime();
ETAP_PlayPCM();
ETAP_CaptureScreen();

ETAP_SetSystemVar();
ETAP_GetSystemVar();
ETAP_WriteSystemVar();
ETAP_GenerateEvent();

// -- OSD FUNCTION ---------------------------------------------------
ETAP_Osd_Create();
ETAP_Osd_Delete();
ETAP_Osd_Move();
ETAP_Osd_FillBox();
ETAP_Osd_PutBox();
ETAP_Osd_GetBox();
ETAP_Osd_SetLut();
ETAP_Osd_Ctrl();
ETAP_Osd_SetTransparency();

ETAP_Osd_Draw3dBox();
ETAP_Osd_Draw3dBoxFill();

ETAP_Osd_DrawRectangle();
ETAP_Osd_DrawPixmap();
ETAP_Osd_Zoom();
ETAP_Osd_GetBaseInfo();
ETAP_Osd_Copy();
TAP_Osd_PutGd();

ETAP_Osd_SaveBox();
ETAP_Osd_RestoreBox();

ETAP_Osd_GetPixel();
ETAP_Osd_PutPixel();

// -- HDD FUNCTION ---------------------------------------------------

ETAP_Hdd_Fopen();
ETAP_Hdd_Fread();
ETAP_Hdd_Fwrite();
ETAP_Hdd_Fclose();
ETAP_Hdd_FindFirst();
ETAP_Hdd_FindNext();
ETAP_Hdd_Fseek();
ETAP_Hdd_Flen();
ETAP_Hdd_Ftell();
ETAP_Hdd_TotalSize();
ETAP_Hdd_FreeSize();
ETAP_Hdd_Delete();
ETAP_Hdd_Exist();
ETAP_Hdd_Create();
ETAP_Hdd_ChangeDir();

ETAP_Hdd_PlayTs();
ETAP_Hdd_StopTs();
ETAP_Hdd_PlayMp3();
ETAP_Hdd_StopMp3();
ETAP_Hdd_Rename();


// -- STRING FUNCTION ---------------------
ETAP_Osd_PutS();
ETAP_Osd_GetW();
ETAP_Osd_PutString();
ETAP_Osd_DrawString();
ETAP_Osd_PutStringAf();

// -- WINDOW FUNCTION ---------------------------------------------------
ETAP_Win_SetTitle();
ETAP_Win_SetColor();
ETAP_Win_SetDefaultColor();
ETAP_Win_Draw();
ETAP_Win_Create();
ETAP_Win_Delete();
ETAP_Win_SetFont();
ETAP_Win_AddItem();
ETAP_Win_GetSelection();
ETAP_Win_SetSelection();
ETAP_Win_Action();

// ---------------------------------------------------------------------

ETAP_Channel_GetTotalNum();
ETAP_Channel_GetFirstInfo();
ETAP_Channel_GetNextInfo();
ETAP_Channel_GetInfo();
ETAP_Channel_GetCurrent();
ETAP_Channel_Start();
ETAP_Channel_Scale();
ETAP_Channel_IsPlayable();
ETAP_Channel_Move();
ETAP_Channel_Stop();
ETAP_Channel_GetTotalAudioTrack();
ETAP_Channel_GetAudioTrackName();
ETAP_Channel_SetAudioTrack();
ETAP_Channel_GetTotalSubtitleTrack();
ETAP_Channel_GetSubtitleTrackName();
ETAP_Channel_SetSubtitleTrack();

ETAP_GetEvent();
ETAP_GetCurrentEvent();

// --- USB FUNCTIONS ---------------------------------------------------

ETAP_Usb_Read();
ETAP_Usb_Write();
ETAP_Usb_PacketRead();
ETAP_Usb_PacketWrite();
ETAP_Usb_Cancel();

// --- TIMER FUNCTIONS ---------------------------------------------------

ETAP_Timer_GetTotalNum();
ETAP_Timer_GetInfo();
ETAP_Timer_Add();
ETAP_Timer_Modify();
ETAP_Timer_Delete();

// ---------------------------------------------------------------------
