// -- DEBUG FUNCTION --------------------------------------------------
void	ETAP_Debug_BufferT2P();
void	ETAP_Debug_BufferP2T();
void	ETAP_Debug_QuitDebugger();


// -- SYSTEM FUNCTION ---------------------------------------------------
void	ETAP_SystemProc();
void	ETAP_GetState();
void	ETAP_ExitNormal();
void	ETAP_EnterNormal();
void	ETAP_Exit();

void	ETAP_KbHit();
void	ETAP_GetCh();
void	ETAP_PutCh();
void	ETAP_Print();

// -- COMMON FUNCTION ---------------------------------------------------
void	    ETAP_SetSoundLevel();
void	    ETAP_GetTime();
void	ETAP_MemInfo();
void	ETAP_MemAlloc();
void	    ETAP_MemFree();
void	ETAP_GetTick();
void	ETAP_Delay();
void	    ETAP_ExtractMjd();
void	    ETAP_MakeMjd();
void	ETAP_Sin();
void	ETAP_Cos();
void	ETAP_SPrint();
void 	ETAP_GetSignalLevel();
void 	ETAP_GetSignalQuality();
void 	ETAP_SetInfoboxTime();
void		ETAP_PlayPCM();
void 	ETAP_CaptureScreen();

void 	ETAP_SetSystemVar();
void 	ETAP_GetSystemVar();
void 	ETAP_WriteSystemVar();
void	ETAP_GenerateEvent();

// -- OSD FUNCTION ---------------------------------------------------
void	ETAP_Osd_Create();
void	ETAP_Osd_Delete();
void	ETAP_Osd_Move();
void	ETAP_Osd_FillBox();
void	ETAP_Osd_PutBox();
void	ETAP_Osd_GetBox();
void	ETAP_Osd_SetLut();
void	ETAP_Osd_Ctrl();
void	ETAP_Osd_SetTransparency();

void	ETAP_Osd_Draw3dBox();
void	ETAP_Osd_Draw3dBoxFill();

void	ETAP_Osd_DrawRectangle();
void	ETAP_Osd_DrawPixmap();
void ETAP_Osd_Zoom();
void ETAP_Osd_GetBaseInfo();
void ETAP_Osd_Copy();
void	ETAP_Osd_PutGd();

void	ETAP_Osd_SaveBox();
void	ETAP_Osd_RestoreBox();

void	ETAP_Osd_GetPixel();
void	ETAP_Osd_PutPixel();

// -- HDD FUNCTION ---------------------------------------------------

void	ETAP_Hdd_Fopen();
void		ETAP_Hdd_Fread();
void		ETAP_Hdd_Fwrite();
void		ETAP_Hdd_Fclose();
void		ETAP_Hdd_FindFirst();
void		ETAP_Hdd_FindNext();
void		ETAP_Hdd_Fseek();
void		ETAP_Hdd_Flen();
void		ETAP_Hdd_Ftell();
void		ETAP_Hdd_TotalSize();
void		ETAP_Hdd_FreeSize();
void		ETAP_Hdd_Delete();
void		ETAP_Hdd_Exist();
void		ETAP_Hdd_Create();
void		ETAP_Hdd_ChangeDir();

void			ETAP_Hdd_PlayTs();
void			ETAP_Hdd_StopTs();
void			ETAP_Hdd_PlayMp3();
void			ETAP_Hdd_StopMp3();
void		ETAP_Hdd_Rename();


// -- STRING FUNCTION ---------------------
void	ETAP_Osd_PutS();
void	ETAP_Osd_GetW();
void	ETAP_Osd_PutString();
void	ETAP_Osd_DrawString();
void	ETAP_Osd_PutStringAf();

// -- WINDOW FUNCTION ---------------------------------------------------
void	ETAP_Win_SetTitle();
void	ETAP_Win_SetColor();
void	ETAP_Win_SetDefaultColor();
void	ETAP_Win_Draw();
void	ETAP_Win_Create();
void	ETAP_Win_Delete();
void	ETAP_Win_SetFont();
void	ETAP_Win_AddItem();
void	ETAP_Win_GetSelection();
void	ETAP_Win_SetSelection();
void	ETAP_Win_Action();

// ---------------------------------------------------------------------

void ETAP_Channel_GetTotalNum();
void ETAP_Channel_GetFirstInfo();
void ETAP_Channel_GetNextInfo();
void ETAP_Channel_GetInfo();
void ETAP_Channel_GetCurrent();
void ETAP_Channel_Start();
void ETAP_Channel_Scale();
void ETAP_Channel_IsPlayable();
void ETAP_Channel_Move();
void ETAP_Channel_Stop();
void ETAP_Channel_GetTotalAudioTrack();
void ETAP_Channel_GetAudioTrackName();
void ETAP_Channel_SetAudioTrack();
void ETAP_Channel_GetTotalSubtitleTrack();
void ETAP_Channel_GetSubtitleTrackName();
void ETAP_Channel_SetSubtitleTrack();

void	ETAP_GetEvent();
void	ETAP_GetCurrentEvent();

// --- USB FUNCTIONS ---------------------------------------------------

void ETAP_Usb_Read();
void ETAP_Usb_Write();
void ETAP_Usb_PacketRead();
void ETAP_Usb_PacketWrite();
void ETAP_Usb_Cancel();

// --- TIMER FUNCTIONS ---------------------------------------------------

void  ETAP_Timer_GetTotalNum();
void ETAP_Timer_GetInfo();
void ETAP_Timer_Add();
void ETAP_Timer_Modify();
void ETAP_Timer_Delete();

// ---------------------------------------------------------------------
