//#define SENDRECTAP() {TRACE("#SENDBUFFER\n"); SendBuffer(); TRACE("#RECEIVEBUFFER\n"); while (ReceiveBuffer()==-1) {TRACE("!SENDBREAK\n"); SendBreak(); TRACE("#SENDBUFFER\n"); SendBuffer(); TRACE("#RECEIVEBUFFER\n"); };}
#define SENDRECTAP() {while (SendBuffer()==-1) {SendBreak();}; while (ReceiveBuffer()==-1) {SendBreak(); while (SendBuffer()==-1) {SendBreak();};};}

#undef NOT_IMPLEMENTED
#define NOT_IMPLEMENTED() {TRACE("!!STAP NOT IMPLEMENTED!!\n");}

#undef W
#undef L
#undef B
#undef U
#undef C

#define C(x)		CreateMessage(ob, x)
#define W(x)		AddWordParm(ob, x)
#define L(x)		AddLongParm(ob, x)
#define B(x)		AddByteParm(ob, x)
#define U(x, len)		AddBufferParm(ob, x, len)


// -- SYSTEM FUNCTION ---------------------------------------------------
void	STAP_SystemProc(void)
{
	CreateMessage(ob, CTAP_SystemProc);
}

LONG	STAP_GetState( LONG *state, LONG *subState )
{
	CreateMessage(ob, CTAP_GetState);

	return 0;
}

void	STAP_ExitNormal( void )
{
	CreateMessage(ob, CTAP_ExitNormal);
}

void	STAP_EnterNormal( void )
{
	CreateMessage(ob, CTAP_EnterNormal);
}

void	STAP_Exit(void)
{
	CreateMessage(ob, CTAP_Exit);
}


/*
CHAR	STAP_KbHit(void)
{
	CreateMessage(ob, CTAP_KbHit);
	return 0;
}

CHAR	STAP_GetCh)(void);
CHAR	SSTAP_GetCh)(void);
CHAR	SATAP_GetCh)(void);

void	STAP_PutCh)(CHAR c);
void	SSTAP_PutCh)(CHAR c);
void	SATAP_PutCh)(CHAR c);

void	STAP_Print)(const void *fmt, ...);
void	SSTAP_Print)(const void *fmt, ...);
void	SATAP_Print)(const void *fmt, ...);
*/

// -- COMMON FUNCTION ---------------------------------------------------
int	STAP_SetSoundLevel(CHAR soundLevel)
{
	C(CTAP_SetSoundLevel);
	B(soundLevel);
	return 0;
}

int	    STAP_GetTime(WORD *mjd, CHAR *hour, CHAR *min, CHAR *sec)
{
	C(CTAP_GetTime);
	return 0;
}


void	STAP_MemInfo(LONG *heapSize, LONG *freeHeapSize, LONG *availHeapSize)
{
	C(CTAP_MemInfo);
}


void	*STAP_MemAlloc(LONG size)
{
	C(CTAP_MemAlloc);
	L(size);

	return NULL;
}


int	    STAP_MemFree(const void *addr)
{
	C(CTAP_MemFree);
	L((LONG)addr);
	
	return 0;
}


LONG	STAP_GetTick(void)
{
	C(CTAP_GetTick);

	return 0;
}


void	STAP_Delay(LONG dm10)
{
	C(CTAP_Delay);
	L(dm10);
}


int	    STAP_ExtractMjd(WORD mjd, WORD *year, CHAR *month, CHAR *day, CHAR *weekDay)
{
	C(CTAP_ExtractMjd);
	W(mjd);

	return 0;

}


int	    STAP_MakeMjd(WORD year, CHAR month, CHAR day)
{

	C(CTAP_MakeMjd);
	W(year);
	B(month);
	B(day);

	return 0;
}


long	STAP_Sin( long mul, long th )
{

	C(CTAP_Sin);
	L(mul);
	L(th);

	return 0;
}


long	STAP_Cos( long mul, long th )
{
	C(CTAP_Cos);
	L(mul);
	L(th);

	return 0;
}


void	STAP_SPrint(void *s, const void *fmt, ...)
{

	NOT_IMPLEMENTED();

}


int 	STAP_GetSignalLevel(void)
{
	C(CTAP_GetSignalLevel);

	return 0;
}


int 	STAP_GetSignalQuality(void)
{
	C(CTAP_GetSignalQuality);

	return 0;
}


int 	STAP_SetInfoboxTime( int sec )
{
	C(CTAP_SetInfoboxTime);
	W(sec);

	return 0;
}


int	STAP_PlayPCM( void *pcmdata, int size, int freq, void (*Callback)(void) )
{
	NOT_IMPLEMENTED();

	return 0;
}


int 	STAP_CaptureScreen( int mainSub, TYPE_VideoBank *videoBank )
{
	NOT_IMPLEMENTED();
	
	return 0;
}



int 	STAP_SetSystemVar( int varId, int value )
{
	C(CTAP_SetSystemVar);
	W(varId);
	W(value);

	return 0;
}


int 	STAP_GetSystemVar( int varId )
{

	C(CTAP_GetSystemVar);
	W(varId);

	return 0;
}


int 	STAP_WriteSystemVar( void )
{

	C(CTAP_WriteSystemVar);

	return 0;
}


void	STAP_GenerateEvent(  WORD evtCode, LONG param1, LONG param2 )
{

	C(CTAP_GenerateEvent);
	W(evtCode);
	L(param1);
	L(param2);
}



/*



// -- OSD FUNCTION ---------------------------------------------------
*/

int	 STAP_Osd_Create( LONG x, LONG y, LONG w, LONG h, CHAR lutIdx, int flag )
{
	CreateMessage(ob, CTAP_Osd_Create);
	AddLongParm(ob, x);
	AddLongParm(ob, y);
	AddLongParm(ob, w);
	AddLongParm(ob, h);
	AddByteParm(ob, lutIdx);
	AddWordParm(ob, flag);
	return 0;
}

int	STAP_Osd_Delete(WORD rgn)
{
	CreateMessage(ob, CTAP_Osd_Delete);
	AddWordParm(ob, rgn);
	return 0;
}

int	STAP_Osd_Move(WORD rgn, LONG x, LONG y)
{
	CreateMessage(ob, CTAP_Osd_Move);
	AddWordParm(ob, rgn);
	AddLongParm(ob, x);
	AddLongParm(ob, y);
	return 0;
}

int	STAP_Osd_FillBox(WORD rgn, LONG x, LONG y, LONG w, LONG h, LONG color)
{
	CreateMessage(ob, CTAP_Osd_FillBox);
	AddWordParm(ob, rgn);
	AddLongParm(ob, x);
	AddLongParm(ob, y);
	AddLongParm(ob, w);
	AddLongParm(ob, h);
	AddLongParm(ob, color);
	return 0;
}



int	STAP_Osd_PutBox(WORD rgn, LONG x, LONG y, LONG w, LONG h, const void *data, bool sprite, CHAR dataFormat )
{
	C(CTAP_Osd_PutBox);
	W(rgn);
	L(x);
	L(y);
	L(w);
	L(h);
	L((LONG)data);
	B(sprite);
	B(dataFormat);

	return 0;
}


int	STAP_Osd_GetBox(WORD rgn, LONG x, LONG y, LONG w, LONG h, void *data)
{
	C(CTAP_Osd_GetBox);
	W(rgn);
	L(x);
	L(y);
	L(w);
	L(h);
	L((LONG)data);

	return 0;

}


int	STAP_Osd_SetLut(CHAR lutIdx, CHAR lut[][4] )
{
	WORD len = 256*4;
	C(CTAP_Osd_SetLut);
	B(lutIdx);
	U((CHAR *)lut, len);

	return 0;
}


int	STAP_Osd_Ctrl(WORD rgn, LONG ctrl)
{
	C(CTAP_Osd_Ctrl);
	W(rgn);
	L(ctrl);

	return 0;
}


int	STAP_Osd_SetTransparency( WORD rgn, char rt)
{
	C(CTAP_Osd_SetTransparency);
	W(rgn);
	B(rt);

	return 0;

}



int	STAP_Osd_Draw3dBox( WORD rgn, LONG x, LONG y, LONG w, LONG h, LONG c1, LONG c2 )
{
	C(CTAP_Osd_Draw3dBox);
	W(rgn);
	L(x);
	L(y);
	L(w);
	L(h);
	L(c1);
	L(c2);

	return 0;
}


int	STAP_Osd_Draw3dBoxFill( WORD rgn, LONG x, LONG y, LONG w, LONG h, LONG c1, LONG c2, LONG fc )
{
	C(CTAP_Osd_Draw3dBoxFill);
	W(rgn);
	L(x);
	L(y);
	L(w);
	L(h);
	L(c1);
	L(c2);
	L(fc);

	return 0;
}



int	STAP_Osd_DrawRectangle(WORD rgn, LONG x, LONG y, LONG w, LONG h, LONG t, LONG color)
{
	C(CTAP_Osd_DrawRectangle);
	W(rgn);
	L(x);
	L(y);
	L(w);
	L(h);
	L(t);
	L(color);

	return 0;
}


int	STAP_Osd_DrawPixmap(WORD rgn, LONG x, LONG y, LONG w, LONG h, void *pixmap, bool sprite, CHAR dataFormat )
{
	C(CTAP_Osd_DrawPixmap);
	W(rgn);
	L(x);
	L(y);
	L(w);
	L(h);
	L((LONG)pixmap);
	B(sprite);
	B(dataFormat);

	return 0;
}


int STAP_Osd_Zoom( int xzoom, int yzoom )
{
	C(CTAP_Osd_Zoom);
	W(xzoom);
	W(yzoom);

	return 0;
}


int STAP_Osd_GetBaseInfo( TYPE_OsdBaseInfo *info )
{
	WORD len = sizeof(TYPE_OsdBaseInfo);

	C(CTAP_Osd_GetBaseInfo);
	U((CHAR *)info, len);

	return 0;
}


int STAP_Osd_Copy(WORD srcRgnNum, WORD dstRgnNum, LONG srcX, LONG srcY, LONG w, LONG h, LONG dstX, LONG dstY,  bool sprite)
{
	C(CTAP_Osd_Copy);
	W(srcRgnNum);
	W(dstRgnNum);
	L(srcX);
	L(srcY);
	L(w);
	L(h);
	L(dstX);
	L(dstY);
	B(sprite);

	return 0;
}


int	STAP_Osd_PutGd(WORD rgn, int x, int y, TYPE_GrData * gd, bool sprite)
{
	C(CTAP_Osd_PutGd);
	W(rgn);
	W(x);
	W(y);
	L((LONG)gd);
	B(sprite);

	return 0;
}



CHAR*	STAP_Osd_SaveBox( WORD rgn, LONG x, LONG y, LONG w, LONG h )
{
	C(CTAP_Osd_SaveBox);
	W(rgn);
	L(x);
	L(y);
	L(w);
	L(h);

	return 0;
}


void	STAP_Osd_RestoreBox( WORD rgn, LONG x, LONG y, LONG w, LONG h, void *data )
{
	C(CTAP_Osd_RestoreBox);
	W(rgn);
	L(x);
	L(y);
	L(w);
	L(h);
	L((LONG)data);
}



int	STAP_Osd_GetPixel( WORD rgn, LONG x, LONG y, void *pix )
{
	C(CTAP_Osd_GetPixel);
	W(rgn);
	L(x);
	L(y);
	L((LONG)pix);

	return 0;
}



int	STAP_Osd_PutPixel( WORD rgn, LONG x, LONG y, LONG pix )
{
	CreateMessage(ob, CTAP_Osd_PutPixel);
	AddWordParm(ob, rgn);
	AddLongParm(ob, x);
	AddLongParm(ob, y);
	AddLongParm(ob, pix);
	return 0;

}

// -- HDD FUNCTION ---------------------------------------------------

TYPE_File*	STAP_Hdd_Fopen( char *name )
{
	C(CTAP_Hdd_Fopen);
	U((unsigned char*)name, strlen(name));

	return 0;

}


LONG		STAP_Hdd_Fread( void *buf, LONG blksize, LONG blk, TYPE_File *file )
{
	C(CTAP_Hdd_Fread);
	L((LONG)buf);
	L(blksize);
	L(blk);
	L((LONG)file);

	return 0;
}


LONG		STAP_Hdd_Fwrite( void *buf, LONG blksize, LONG blk, TYPE_File *file )
{
	C(CTAP_Hdd_Fwrite);
	L((LONG)buf);
	L(blksize);
	L(blk);
	L((LONG)file);

	return 0;
}


void		STAP_Hdd_Fclose( TYPE_File *file )
{
	C(CTAP_Hdd_Fclose);
	L((LONG)file);
}


LONG		STAP_Hdd_FindFirst( TYPE_File *file )
{
	C(CTAP_Hdd_FindFirst);
	L((LONG)file);

	return 0;
}


LONG		STAP_Hdd_FindNext( TYPE_File *file )
{
	C(CTAP_Hdd_FindNext);
	L((LONG)file);

	return 0;
}


LONG		STAP_Hdd_Fseek( TYPE_File *file, long pos, long where )
{
	C(CTAP_Hdd_Fseek);
	L((LONG)file);
	L(pos);
	L(where);

	return 0;
}


LONG		STAP_Hdd_Flen( TYPE_File *file )
{
	C(CTAP_Hdd_Flen);
	L((LONG)file);

	return 0;
}


LONG		STAP_Hdd_Ftell( TYPE_File *file )
{
	C(CTAP_Hdd_Ftell);
	L((LONG)file);

	return 0;
}


LONG		STAP_Hdd_TotalSize( void )
{
	C(CTAP_Hdd_TotalSize);

	return 0;
}


LONG		STAP_Hdd_FreeSize( void )
{
	C(CTAP_Hdd_FreeSize);

	return 0;
}


WORD		STAP_Hdd_Delete( char *name )
{
	C(CTAP_Hdd_Delete);
	U((unsigned char*)name, strlen(name));

	return 0;
}


bool		STAP_Hdd_Exist( char *name )
{
	C(CTAP_Hdd_Exist);
	U((unsigned char*)name, strlen(name));

	return 0;
}


LONG		STAP_Hdd_Create( char *name, CHAR attr )
{
	C(CTAP_Hdd_Create);
	U((unsigned char*)name, strlen(name));
	B(attr);

	return 0;
}


WORD		STAP_Hdd_ChangeDir( char *dir )
{
	C(CTAP_Hdd_ChangeDir);
	U((unsigned char*)dir, strlen(dir));

	return 0;
}



int			STAP_Hdd_PlayTs( char *name )
{
	C(CTAP_Hdd_PlayTs);
	U((unsigned char*)name, strlen(name));

	return 0;
}


int			STAP_Hdd_StopTs( void)
{
	C(CTAP_Hdd_StopTs);

	return 0;

}


int			STAP_Hdd_PlayMp3( char *name )
{
	C(CTAP_Hdd_PlayMp3);
	U((unsigned char*)name, strlen(name));

	return 0;
}


int			STAP_Hdd_StopMp3( void )
{
	C(CTAP_Hdd_StopMp3);
	
	return 0;

}


bool		STAP_Hdd_Rename(   	char *oldName, char *newName )
{
	C(CTAP_Hdd_Delete);
	U((unsigned char*)oldName, strlen(oldName));
	U((unsigned char*)newName, strlen(newName));

	return 0;
}




// -- STRING FUNCTION ---------------------
int	STAP_Osd_PutS(WORD rgn, LONG x, LONG y, LONG maxX, const char * str, WORD fcolor, WORD bcolor, CHAR fntType, CHAR fntSize, CHAR bDot, CHAR align)
{
	C(CTAP_Osd_PutS);
	W(rgn);
	L(x);
	L(y);
	L(maxX);
	U((unsigned char*)str, strlen(str));
	W(fcolor);
	W(bcolor);
	B(fntType);
	B(fntSize);
	B(bDot);
	B(align);

	return 0;

}


int	STAP_Osd_GetW( const char *str, CHAR fntType, CHAR fntSize )
{
	C(CTAP_Osd_GetW);
	U((unsigned char*)str, strlen(str));
	B(fntType);
	B(fntSize);

	return 0;
}


int	STAP_Osd_PutString(WORD rgn, LONG x, LONG y, LONG maxX, const char * str, WORD fcolor, WORD bcolor, CHAR fntType, CHAR fntSize, CHAR nextLine)
{
	C(CTAP_Osd_PutString);
	W(rgn);
	L(x);
	L(y);
	L(maxX);
	U((unsigned char*)str, strlen(str));
	W(fcolor);
	W(bcolor);
	B(fntType);
	B(fntSize);
	B(nextLine);

	return 0;
}


int	STAP_Osd_DrawString(const char * str, LONG dstWidth, WORD color, CHAR * dest, LONG maxWidth, CHAR fntType, CHAR fntSize)
{
	C(CTAP_Osd_DrawString);
	U((unsigned char*)str, strlen(str));
	L(dstWidth);
	W(color);
	L((LONG)dest);
	L(maxWidth);
	B(fntType);
	B(fntSize);

	return 0;
}


int	STAP_Osd_PutStringAf(WORD rgn, LONG x, LONG y, LONG maxX, const char * str, WORD fcolor, WORD bcolor, CHAR fntType, CHAR fntSize, CHAR nextLine)
{
	C(CTAP_Osd_PutStringAf);
	W(rgn);
	L(x);
	L(y);
	L(maxX);
	U((unsigned char*)str, strlen(str));
	W(fcolor);
	W(bcolor);
	B(fntType);
	B(fntSize);
	B(nextLine);

	return 0;
}



// -- WINDOW FUNCTION ---------------------------------------------------
void	STAP_Win_SetTitle( TYPE_Window *win, const char *str, CHAR fntType, CHAR fntSize )
{
	C(CTAP_Win_SetTitle);
	L((LONG)win);
	U((unsigned char*)str, strlen(str));
	B(fntType);
	B(fntSize);
}


void	STAP_Win_SetColor(TYPE_Window * win, WORD titleBack, WORD titleText, WORD bodyBack, WORD bodyText, WORD border, WORD shadow, WORD dark, WORD light)
{
	C(CTAP_Win_SetColor);
	L((LONG)win);
	W(titleBack);
	W(titleText);
	W(bodyBack);
	W(bodyText);
	W(border);
	W(shadow);
	W(dark);
	W(light);
}


void	STAP_Win_SetDefaultColor( TYPE_Window *win )
{
	C(CTAP_Win_SetDefaultColor);
	L((LONG)win);
}


void	STAP_Win_Draw( TYPE_Window *win )
{
	C(CTAP_Win_Draw);
	L((LONG)win);
}


void	STAP_Win_Create( TYPE_Window *win, WORD rgn, LONG x, LONG y, LONG w, LONG h, CHAR save, CHAR bScr )
{
	C(CTAP_Win_Create);
	L((LONG)win);
	W(rgn);
	L(x);
	L(y);
	L(w);
	L(h);
	B(save);
	B(bScr);
}


LONG	STAP_Win_Delete( TYPE_Window *win )
{
	C(CTAP_Win_Delete);
	L((LONG)win);

	return 0;
}


void	STAP_Win_SetFont( TYPE_Window *win, CHAR fntType, CHAR fntSize )
{
	C(CTAP_Win_SetFont);
	L((LONG)win);
	B(fntType);
	B(fntSize);
}


void	STAP_Win_AddItem( TYPE_Window *win, char *str )
{
	C(CTAP_Win_AddItem);
	L((LONG)win);
	U((unsigned char*)str, strlen(str));
}


LONG	STAP_Win_GetSelection( TYPE_Window *win )
{
	C(CTAP_Win_GetSelection);
	L((LONG)win);

	return 0;
}


void	STAP_Win_SetSelection( TYPE_Window *win, LONG pos )
{
	C(CTAP_Win_SetSelection);
	L((LONG)win);
	L(pos);
}


void	STAP_Win_Action( TYPE_Window *win, LONG key )
{
	C(CTAP_Win_Action);
	L((LONG)win);
	L(key);
}



// ---------------------------------------------------------------------

int STAP_Channel_GetTotalNum( int *nTvSvc, int *nRadioSvc )
{
	C(CTAP_Channel_GetTotalNum);

	return 0;
}


int STAP_Channel_GetFirstInfo( int svcType, TYPE_TapChInfo *chInfo )
{
	C(CTAP_Channel_GetFirstInfo);
	W((WORD)svcType);

	return 0;
}


int STAP_Channel_GetNextInfo( TYPE_TapChInfo *chInfo )
{
	C(CTAP_Channel_GetNextInfo);

	return 0;

}


int STAP_Channel_GetInfo( int svcType, int svcNum, TYPE_TapChInfo *chInfo )
{
	C(CTAP_Channel_GetInfo);
	W(svcType);
	W(svcNum);

	return 0;
}


int STAP_Channel_GetCurrent( int *tvRadio, int *svcNum )
{
	C(CTAP_Channel_GetCurrent);

	return 0;
}


int STAP_Channel_Start( int mainSub, int svcType, int chNum )
{
	C(CTAP_Channel_Start);
	W(mainSub);
	W(svcType);
	W(chNum);

	return 0;
}


int STAP_Channel_Scale( int mainSub, long x, long y, long w, long h, bool anim )
{
	C(CTAP_Channel_Scale);
	W(mainSub);
	L(x);
	L(y);
	L(w);
	L(h);
	B(anim);

	return 0;
}


int STAP_Channel_IsPlayable( int mainSub, int svcType, int chNum )
{
	C(CTAP_Channel_IsPlayable);
	W(mainSub);
	W(svcType);
	W(chNum);

	return 0;
}


int STAP_Channel_Move( int mainSub, int dir )
{
	C(CTAP_Channel_Move);
	W(mainSub);
	W(dir);

	return 0;
}


int STAP_Channel_Stop( int mainSub )
{
	C(CTAP_Channel_Stop);
	W(mainSub);

	return 0;
}


int STAP_Channel_GetTotalAudioTrack( void )
{
	C(CTAP_Channel_GetTotalAudioTrack);

	return 0;
}


char *STAP_Channel_GetAudioTrackName( int trkNum, char *trkName )
{
	C(CTAP_Channel_GetAudioTrackName);
	W(trkNum);

	return 0;
}


int STAP_Channel_SetAudioTrack( int trkNum )
{
	C(CTAP_Channel_SetAudioTrack);
	W(trkNum);

	return 0;
}


int STAP_Channel_GetTotalSubtitleTrack( void )
{
	C(CTAP_Channel_GetTotalSubtitleTrack);

	return 0;
}


char *STAP_Channel_GetSubtitleTrackName( int trkNum, char *trkName )
{
	C(CTAP_Channel_GetSubtitleTrackName);
	W(trkNum);

	return 0;
}


int STAP_Channel_SetSubtitleTrack( int trkNum )
{
	C(CTAP_Channel_SetSubtitleTrack);
	W(trkNum);

	return 0;
}



TYPE_TapEvent*	STAP_GetEvent( int svcType, int svcNum, int *eventNum )
{
	C(CTAP_GetEvent);
	W(svcType);
	W(svcNum);
	
	return 0;
}


TYPE_TapEvent*	STAP_GetCurrentEvent( int svcType, int svcNum )
{
	C(CTAP_GetCurrentEvent);
	W(svcType);
	W(svcNum);

	return 0;
}



// --- USB FUNCTIONS ---------------------------------------------------

void STAP_Usb_Read( CHAR *pBuff, WORD size, void (*pFunc)(WORD size) )
{
	NOT_IMPLEMENTED();


}


void STAP_Usb_Write( CHAR *pBuff, WORD size, void (*pFunc)(WORD size) )
{
	NOT_IMPLEMENTED();


}


void STAP_Usb_PacketRead( CHAR *pBuff, WORD size, WORD (*pFunc)(WORD size) )
{
	NOT_IMPLEMENTED();


}


void STAP_Usb_PacketWrite( CHAR *pBuff, WORD size, void (*pFunc)(WORD size), LONG cmd )
{
	NOT_IMPLEMENTED();


}


void STAP_Usb_Cancel(void)
{
	NOT_IMPLEMENTED();


}



// --- TIMER FUNCTIONS ---------------------------------------------------

int  STAP_Timer_GetTotalNum( void )
{
	C(CTAP_Timer_GetTotalNum);

	return 0;
}


// buffer transfer
bool STAP_Timer_GetInfo( int entryNum, TYPE_TimerInfo *info )
{
	C(CTAP_Timer_GetInfo);
	W(entryNum);

	return 0;
}


int STAP_Timer_Add( TYPE_TimerInfo *info )
{
	C(CTAP_Timer_Add);
	U((CHAR*)info, sizeof(TYPE_TimerInfo));

	return 0;
}


int STAP_Timer_Modify( int entryNum, TYPE_TimerInfo *info )
{
	C(CTAP_Timer_Modify);
	U((CHAR*)info, sizeof(TYPE_TimerInfo));

	return 0;
}


bool STAP_Timer_Delete( int entryNum )
{
	C(CTAP_Timer_Delete);
	W(entryNum);

	return 0;
}


// ---------------------------------------------------------------------

// DEBUG FUNCTIONS
void STAP_Debug_BufferT2P(void *target, LONG topfpointer, WORD length)
{
	C(CTAP_Debug_BufferT2P);
	L(topfpointer);
	W(length);
}


void STAP_Debug_BufferP2T(void *source, LONG topfpointer, WORD length)
{
	C(CTAP_Debug_BufferP2T);
	L(topfpointer);
	U((CHAR*)source, length);
}

void STAP_Debug_QuitDebugger()
{
	C(CTAP_Debug_QuitDebugger);
}