#undef NOT_IMPLEMENTED
#define USENDRECTAP() {TRACE("!!TAP NOT IMPLEMENTED!!\n"); MessageBeep(-1);}




// -- SYSTEM FUNCTION ---------------------------------------------------
void	TAP_SystemProc(void)
{
	STAP_SystemProc();
	SENDRECTAP();
	ATAP_SystemProc();
}

LONG	TAP_GetState( LONG *state, LONG *subState )
{
	STAP_GetState(state, subState);
	SENDRECTAP();
	return ATAP_GetState(state, subState);
}

void	TAP_ExitNormal( void )
{
	STAP_ExitNormal();
	SENDRECTAP();
	ATAP_ExitNormal();
}


void	TAP_EnterNormal( void )
{
	STAP_EnterNormal();
	SENDRECTAP();
	ATAP_EnterNormal();
}

void	TAP_Exit(void)
{
	STAP_Exit();
	SENDRECTAP();
	ATAP_Exit();
}



/*
CHAR	TAP_KbHit(void)
{
	TAP_KbHit();
	SENDRECTAP();
	return TAP_KbHit();
}


CHAR	(*TAP_GetCh)(void);
CHAR	(*TAP_GetCh)(void);
CHAR	(*TAP_GetCh)(void);

void	(*TAP_PutCh)(CHAR c);
void	(*TAP_PutCh)(CHAR c);
void	(*TAP_PutCh)(CHAR c);

void	(*TAP_Print)(const void *fmt, ...);
void	(*TAP_Print)(const void *fmt, ...);
void	(*TAP_Print)(const void *fmt, ...);
*/



// -- COMMON FUNCTION ---------------------------------------------------
int	    TAP_SetSoundLevel(CHAR soundLevel)
{
	STAP_SetSoundLevel(soundLevel);
	SENDRECTAP();
	return ATAP_SetSoundLevel(soundLevel);
}

int	    TAP_GetTime(WORD *mjd, CHAR *hour, CHAR *min, CHAR *sec)
{
	STAP_GetTime(mjd, hour, min, sec);
	SENDRECTAP();
	return ATAP_GetTime(mjd, hour, min, sec);
}

void	TAP_MemInfo(LONG *heapSize, LONG *freeHeapSize, LONG *availHeapSize)
{
	STAP_MemInfo(heapSize, freeHeapSize, availHeapSize);
	SENDRECTAP();
	ATAP_MemInfo(heapSize, freeHeapSize, availHeapSize);
}

void	*TAP_MemAlloc(LONG size)
{
	STAP_MemAlloc(size);
	SENDRECTAP();
	return ATAP_MemAlloc(size);

	return NULL;
}

int	    TAP_MemFree(const void *addr)
{
	STAP_MemFree(addr);
	SENDRECTAP();
	return ATAP_MemFree(addr);
}

LONG	TAP_GetTick(void)
{
	STAP_GetTick();
	SENDRECTAP();
	return ATAP_GetTick();
}

void	TAP_Delay(LONG dm10)
{
	STAP_Delay(dm10);
	SENDRECTAP();
	ATAP_Delay(dm10);
}

int	    TAP_ExtractMjd(WORD mjd, WORD *year, CHAR *month, CHAR *day, CHAR *weekDay)
{
	STAP_ExtractMjd(mjd, year, month, day, weekDay);
	SENDRECTAP();
	return ATAP_ExtractMjd(mjd, year, month, day, weekDay);
}

int	    TAP_MakeMjd(WORD year, CHAR month, CHAR day)
{
	STAP_MakeMjd(year, month, day);
	SENDRECTAP();
	return ATAP_MakeMjd(year, month, day);
}

long	TAP_Sin( long mul, long th )
{
	STAP_Sin(mul, th);
	SENDRECTAP();
	return ATAP_Sin(mul, th);
}

long	TAP_Cos( long mul, long th )
{
	STAP_Cos(mul, th);
	SENDRECTAP();
	return ATAP_Cos(mul, th);
}

void	TAP_SPrint(void *s, const void *fmt, ...)
{
	//STAP_SPrint();
	USENDRECTAP();
	//return ATAP_SPrint();
}

int 	TAP_GetSignalLevel(void)
{
	STAP_GetSignalLevel();
	SENDRECTAP();
	return ATAP_GetSignalLevel();
}

int 	TAP_GetSignalQuality(void)
{
	STAP_GetSignalQuality();
	SENDRECTAP();
	return ATAP_GetSignalQuality();
}

int 	TAP_SetInfoboxTime( int sec )
{
	STAP_SetInfoboxTime(sec);
	SENDRECTAP();
	return ATAP_SetInfoboxTime(sec);
}

int		TAP_PlayPCM( void *pcmdata, int size, int freq, void (*Callback)(void) )
{
	//STAP_PlayPCM(pcmdata, size, freq, );
	USENDRECTAP();
	//return ATAP_PlayPCM();

	return 0;
}

int 	TAP_CaptureScreen( int mainSub, TYPE_VideoBank *videoBank )
{
	STAP_CaptureScreen(mainSub, videoBank);
	SENDRECTAP();
	return ATAP_CaptureScreen(mainSub, videoBank);
}

int 	TAP_SetSystemVar( int varId, int value )
{
	STAP_SetSystemVar(varId, value);
	SENDRECTAP();
	return ATAP_SetSystemVar(varId, value);
}

int 	TAP_GetSystemVar( int varId )
{
	STAP_GetSystemVar(varId);
	SENDRECTAP();
	return ATAP_GetSystemVar(varId);
}

int 	TAP_WriteSystemVar( void )
{
	STAP_WriteSystemVar();
	SENDRECTAP();
	return ATAP_WriteSystemVar();
}

void	TAP_GenerateEvent(  WORD evtCode, LONG param1, LONG param2 )
{
	STAP_GenerateEvent(evtCode, param1, param2);
	SENDRECTAP();
	ATAP_GenerateEvent(evtCode, param1, param2);
}


// -- OSD FUNCTION ---------------------------------------------------

int	 TAP_Osd_Create( LONG x, LONG y, LONG w, LONG h, CHAR lutIdx, int flag )
{
	STAP_Osd_Create(x, y, w, h, lutIdx, flag);
	SENDRECTAP();
	return ATAP_Osd_Create(x, y, w, h, lutIdx, flag);
}

int	TAP_Osd_Delete(WORD rgn)
{
	STAP_Osd_Delete(rgn);
	SENDRECTAP();
	return ATAP_Osd_Delete(rgn);
}

int	TAP_Osd_Move(WORD rgn, LONG x, LONG y)
{
	STAP_Osd_Move(rgn, x, y);
	SENDRECTAP();
	return ATAP_Osd_Move(rgn, x, y);
}

int	TAP_Osd_FillBox(WORD rgn, LONG x, LONG y, LONG w, LONG h, LONG color)
{
	STAP_Osd_FillBox(rgn, x, y, w, h, color);
	SENDRECTAP();
	return ATAP_Osd_FillBox(rgn, x, y, w, h, color);
}



int	TAP_Osd_PutBox(WORD rgn, LONG x, LONG y, LONG w, LONG h, const void *data, bool sprite, CHAR dataFormat )
{
	STAP_Osd_PutBox(rgn, x, y, w, h, data, sprite, dataFormat);
	SENDRECTAP();
	return ATAP_Osd_PutBox(rgn, x, y, w, h, data, sprite, dataFormat);
}

int	TAP_Osd_GetBox(WORD rgn, LONG x, LONG y, LONG w, LONG h, void *data)
{
	STAP_Osd_GetBox(rgn, x, y, w, h, data);
	SENDRECTAP();
	return ATAP_Osd_GetBox(rgn, x, y, w, h, data);
}

int	TAP_Osd_SetLut(CHAR lutIdx, CHAR lut[][4] )
{
	STAP_Osd_SetLut(lutIdx, lut);
	SENDRECTAP();
	return ATAP_Osd_SetLut(lutIdx, lut);
}

int	TAP_Osd_Ctrl(WORD rgn, LONG ctrl)
{
	STAP_Osd_Ctrl(rgn, ctrl);
	SENDRECTAP();
	return ATAP_Osd_Ctrl(rgn, ctrl);
}

int	TAP_Osd_SetTransparency( WORD rgn, char rt)
{
	STAP_Osd_SetTransparency(rgn, rt);
	SENDRECTAP();
	return ATAP_Osd_SetTransparency(rgn, rt);
}


int	TAP_Osd_Draw3dBox( WORD rgn, LONG x, LONG y, LONG w, LONG h, LONG c1, LONG c2 )
{
	STAP_Osd_Draw3dBox(rgn, x, y, w, h, c1, c2);
	SENDRECTAP();
	return ATAP_Osd_Draw3dBox(rgn, x, y, w, h, c1, c2);
}

int	TAP_Osd_Draw3dBoxFill( WORD rgn, LONG x, LONG y, LONG w, LONG h, LONG c1, LONG c2, LONG fc )
{
	STAP_Osd_Draw3dBoxFill(rgn, x, y, w, h, c1, c2, fc);
	SENDRECTAP();
	return ATAP_Osd_Draw3dBoxFill(rgn, x, y, w, h, c1, c2, fc);
}


int	TAP_Osd_DrawRectangle(WORD rgn, LONG x, LONG y, LONG w, LONG h, LONG t, LONG color)
{
	STAP_Osd_DrawRectangle(rgn, x, y, w, h, t, color);
	SENDRECTAP();
	return ATAP_Osd_DrawRectangle(rgn, x, y, w, h, t, color);
}

int	TAP_Osd_DrawPixmap(WORD rgn, LONG x, LONG y, LONG w, LONG h, void *pixmap, bool sprite, CHAR dataFormat )
{
	STAP_Osd_DrawPixmap(rgn, x, y, w, h, pixmap, sprite, dataFormat);
	SENDRECTAP();
	return ATAP_Osd_DrawPixmap(rgn, x, y, w, h, pixmap, sprite, dataFormat);
}

int TAP_Osd_Zoom( int xzoom, int yzoom )
{
	STAP_Osd_Zoom(xzoom, yzoom);
	SENDRECTAP();
	return ATAP_Osd_Zoom(xzoom, yzoom);
}

int TAP_Osd_GetBaseInfo( TYPE_OsdBaseInfo *info )
{
	STAP_Osd_GetBaseInfo(info);
	SENDRECTAP();
	return ATAP_Osd_GetBaseInfo(info);
}

int TAP_Osd_Copy(WORD srcRgnNum, WORD dstRgnNum, LONG srcX, LONG srcY, LONG w, LONG h, LONG dstX, LONG dstY,  bool sprite)
{
	STAP_Osd_Copy(srcRgnNum, dstRgnNum, srcX, srcY, w, h, dstX, dstY, sprite);
	SENDRECTAP();
	return ATAP_Osd_Copy(srcRgnNum, dstRgnNum, srcX, srcY, w, h, dstX, dstY, sprite);
}

int	TAP_Osd_PutGd(WORD rgn, int x, int y, TYPE_GrData * gd, bool sprite)
{
	STAP_Osd_PutGd(rgn, x, y, gd, sprite);
	SENDRECTAP();
	return ATAP_Osd_PutGd(rgn, x, y, gd, sprite);
}


CHAR*	TAP_Osd_SaveBox( WORD rgn, LONG x, LONG y, LONG w, LONG h )
{
	STAP_Osd_SaveBox(rgn, x, y, w, h);
	SENDRECTAP();
	return ATAP_Osd_SaveBox(rgn, x, y, w, h);
}

void	TAP_Osd_RestoreBox( WORD rgn, LONG x, LONG y, LONG w, LONG h, void *data )
{
	STAP_Osd_RestoreBox(rgn, x, y, w, h, data);
	SENDRECTAP();
	ATAP_Osd_RestoreBox(rgn, x, y, w, h, data);
}


int	TAP_Osd_GetPixel( WORD rgn, LONG x, LONG y, void *pix )
{
	STAP_Osd_GetPixel(rgn, x, y, pix);
	SENDRECTAP();
	return ATAP_Osd_GetPixel(rgn, x, y, pix);
}



int	TAP_Osd_PutPixel( WORD rgn, LONG x, LONG y, LONG pix )
{
	STAP_Osd_PutPixel(rgn, x, y, pix);
	SENDRECTAP();
	return ATAP_Osd_PutPixel(rgn, x, y, pix);
}

// -- HDD FUNCTION ---------------------------------------------------

TYPE_File*	TAP_Hdd_Fopen( char *name )
{
	STAP_Hdd_Fopen(name);
	SENDRECTAP();
	return ATAP_Hdd_Fopen(name);
}

LONG		TAP_Hdd_Fread( void *buf, LONG blksize, LONG blk, TYPE_File *file )
{
	STAP_Hdd_Fread(buf, blksize, blk, file);
	SENDRECTAP();
	return ATAP_Hdd_Fread(buf, blksize, blk, file);
}

LONG		TAP_Hdd_Fwrite( void *buf, LONG blksize, LONG blk, TYPE_File *file )
{
	STAP_Hdd_Fwrite(buf, blksize, blk, file);
	SENDRECTAP();
	return ATAP_Hdd_Fwrite(buf, blksize, blk, file);
}

void		TAP_Hdd_Fclose( TYPE_File *file )
{
	STAP_Hdd_Fclose(file);
	SENDRECTAP();
	ATAP_Hdd_Fclose(file);
}

LONG		TAP_Hdd_FindFirst( TYPE_File *file )
{
	STAP_Hdd_FindFirst(file);
	SENDRECTAP();
	return ATAP_Hdd_FindFirst(file);
}

LONG		TAP_Hdd_FindNext( TYPE_File *file )
{
	STAP_Hdd_FindNext(file);
	SENDRECTAP();
	return ATAP_Hdd_FindNext(file);
}

LONG		TAP_Hdd_Fseek( TYPE_File *file, long pos, long where )
{
	STAP_Hdd_Fseek(file, pos, where);
	SENDRECTAP();
	return ATAP_Hdd_Fseek(file, pos, where);
}

LONG		TAP_Hdd_Flen( TYPE_File *file )
{
	STAP_Hdd_Flen(file);
	SENDRECTAP();
	return ATAP_Hdd_Flen(file);
}

LONG		TAP_Hdd_Ftell( TYPE_File *file )
{
	STAP_Hdd_Ftell(file);
	SENDRECTAP();
	return ATAP_Hdd_Ftell(file);
}

LONG		TAP_Hdd_TotalSize( void )
{
	STAP_Hdd_TotalSize();
	SENDRECTAP();
	return ATAP_Hdd_TotalSize();
}

LONG		TAP_Hdd_FreeSize( void )
{
	STAP_Hdd_FreeSize();
	SENDRECTAP();
	return ATAP_Hdd_FreeSize();
}

word TAP_Hdd_Delete( char *name )
{
	STAP_Hdd_Delete(name);
	SENDRECTAP();
	return ATAP_Hdd_Delete(name);
}

bool TAP_Hdd_Exist( char *name )
{
	STAP_Hdd_Exist(name);
	SENDRECTAP();
	return ATAP_Hdd_Exist(name);
}

LONG		TAP_Hdd_Create( char *name, CHAR attr )
{
	STAP_Hdd_Create(name, attr);
	SENDRECTAP();
	return ATAP_Hdd_Create(name, attr);
}

word TAP_Hdd_ChangeDir( char *dir )
{
	STAP_Hdd_ChangeDir(dir);
	SENDRECTAP();
	return ATAP_Hdd_ChangeDir(dir);
}


int	TAP_Hdd_PlayTs( char *name )
{
	STAP_Hdd_PlayTs(name);
	SENDRECTAP();
	return ATAP_Hdd_PlayTs(name);
}

int			TAP_Hdd_StopTs( void)
{
	STAP_Hdd_StopTs();
	SENDRECTAP();
	return ATAP_Hdd_StopTs();
}

int			TAP_Hdd_PlayMp3( char *name )
{
	STAP_Hdd_PlayMp3(name);
	SENDRECTAP();
	return ATAP_Hdd_PlayMp3(name);
}

int			TAP_Hdd_StopMp3( void )
{
	STAP_Hdd_StopMp3();
	SENDRECTAP();
	return ATAP_Hdd_StopMp3();
}

bool		TAP_Hdd_Rename(   	char *oldName, char *newName )
{
	STAP_Hdd_Rename(oldName, newName);
	SENDRECTAP();
	return ATAP_Hdd_Rename(oldName, newName);
}



// -- STRING FUNCTION ---------------------
int	TAP_Osd_PutS(WORD rgn, LONG x, LONG y, LONG maxX, const char * str, WORD fcolor, WORD bcolor, CHAR fntType, CHAR fntSize, CHAR bDot, CHAR align)
{
	STAP_Osd_PutS(rgn, x, y, maxX, str, fcolor, bcolor, fntType, fntSize, bDot, align);
	SENDRECTAP();
	return ATAP_Osd_PutS(rgn, x, y, maxX, str, fcolor, bcolor, fntType, fntSize, bDot, align);
}

int	TAP_Osd_GetW( const char *str, CHAR fntType, CHAR fntSize )
{
	STAP_Osd_GetW(str, fntType, fntSize);
	SENDRECTAP();
	return ATAP_Osd_GetW(str, fntType, fntSize);
}

int	TAP_Osd_PutString(WORD rgn, LONG x, LONG y, LONG maxX, const char * str, WORD fcolor, WORD bcolor, CHAR fntType, CHAR fntSize, CHAR nextLine)
{
	STAP_Osd_PutString(rgn, x, y, maxX, str, fcolor, bcolor, fntType, fntSize, nextLine);
	SENDRECTAP();
	return ATAP_Osd_PutString(rgn, x, y, maxX, str, fcolor, bcolor, fntType, fntSize, nextLine);
}

int	TAP_Osd_DrawString(const char * str, LONG dstWidth, WORD color, CHAR * dest, LONG maxWidth, CHAR fntType, CHAR fntSize)
{
	STAP_Osd_DrawString(str, dstWidth, color, dest, maxWidth, fntType, fntSize);
	SENDRECTAP();
	return ATAP_Osd_DrawString(str, dstWidth, color, dest, maxWidth, fntType, fntSize);
}

int	TAP_Osd_PutStringAf(WORD rgn, LONG x, LONG y, LONG maxX, const char * str, WORD fcolor, WORD bcolor, CHAR fntType, CHAR fntSize, CHAR nextLine)
{
	STAP_Osd_PutStringAf(rgn, x, y, maxX, str, fcolor, bcolor, fntType, fntSize, nextLine);
	SENDRECTAP();
	return ATAP_Osd_PutStringAf(rgn, x, y, maxX, str, fcolor, bcolor, fntType, fntSize, nextLine);
}


// -- WINDOW FUNCTION ---------------------------------------------------
void	TAP_Win_SetTitle( TYPE_Window *win, const char *str, CHAR fntType, CHAR fntSize )
{
	STAP_Win_SetTitle(win, str, fntType, fntSize);
	SENDRECTAP();
	ATAP_Win_SetTitle(win, str, fntType, fntSize);
}

void	TAP_Win_SetColor(TYPE_Window * win, WORD titleBack, WORD titleText, WORD bodyBack, WORD bodyText, WORD border, WORD shadow, WORD dark, WORD light)
{
	STAP_Win_SetColor(win, titleBack, titleText, bodyBack, bodyText, border, shadow, dark, light);
	SENDRECTAP();
	ATAP_Win_SetColor(win, titleBack, titleText, bodyBack, bodyText, border, shadow, dark, light);
}

void	TAP_Win_SetDefaultColor( TYPE_Window *win )
{
	STAP_Win_SetDefaultColor(win);
	SENDRECTAP();
	ATAP_Win_SetDefaultColor(win);
}

void	TAP_Win_Draw( TYPE_Window *win )
{
	STAP_Win_Draw(win);
	SENDRECTAP();
	ATAP_Win_Draw(win);
}

void	TAP_Win_Create( TYPE_Window *win, WORD rgn, LONG x, LONG y, LONG w, LONG h, CHAR save, CHAR bScr )
{
	STAP_Win_Create(win, rgn, x, y, w, h, save, bScr);
	SENDRECTAP();
	ATAP_Win_Create(win, rgn, x, y, w, h, save, bScr);
}

LONG	TAP_Win_Delete( TYPE_Window *win )
{
	STAP_Win_Delete(win);
	SENDRECTAP();
	return ATAP_Win_Delete(win);
}

void	TAP_Win_SetFont( TYPE_Window *win, CHAR fntType, CHAR fntSize )
{
	STAP_Win_SetFont(win, fntType, fntSize);
	SENDRECTAP();
	ATAP_Win_SetFont(win, fntType, fntSize);
}

void	TAP_Win_AddItem( TYPE_Window *win, char *str )
{
	STAP_Win_AddItem(win, str);
	SENDRECTAP();
	ATAP_Win_AddItem(win, str);
}

LONG	TAP_Win_GetSelection( TYPE_Window *win )
{
	STAP_Win_GetSelection(win);
	SENDRECTAP();
	return ATAP_Win_GetSelection(win);
}

void	TAP_Win_SetSelection( TYPE_Window *win, LONG pos )
{
	STAP_Win_SetSelection(win, pos);
	SENDRECTAP();
	ATAP_Win_SetSelection(win, pos);
}

void	TAP_Win_Action( TYPE_Window *win, LONG key )
{
	STAP_Win_Action(win, key);
	SENDRECTAP();
	ATAP_Win_Action(win, key);
}


// ---------------------------------------------------------------------

int TAP_Channel_GetTotalNum( int *nTvSvc, int *nRadioSvc )
{
	STAP_Channel_GetTotalNum(nTvSvc, nRadioSvc);
	SENDRECTAP();
	return ATAP_Channel_GetTotalNum(nTvSvc, nRadioSvc);
}

int TAP_Channel_GetFirstInfo( int svcType, TYPE_TapChInfo *chInfo )
{
	STAP_Channel_GetFirstInfo(svcType, chInfo);
	SENDRECTAP();
	return ATAP_Channel_GetFirstInfo(svcType, chInfo);
}

int TAP_Channel_GetNextInfo( TYPE_TapChInfo *chInfo )
{
	STAP_Channel_GetNextInfo(chInfo);
	SENDRECTAP();
	return ATAP_Channel_GetNextInfo(chInfo);
}

int TAP_Channel_GetInfo( int svcType, int svcNum, TYPE_TapChInfo *chInfo )
{
	STAP_Channel_GetInfo(svcType, svcNum, chInfo);
	SENDRECTAP();
	return ATAP_Channel_GetInfo(svcType, svcNum, chInfo);
}

int TAP_Channel_GetCurrent( int *tvRadio, int *svcNum )
{
	STAP_Channel_GetCurrent(tvRadio, svcNum);
	SENDRECTAP();
	return ATAP_Channel_GetCurrent(tvRadio, svcNum);
}

int TAP_Channel_Start( int mainSub, int svcType, int chNum )
{
	STAP_Channel_Start(mainSub, svcType, chNum);
	SENDRECTAP();
	return ATAP_Channel_Start(mainSub, svcType, chNum);
}

int TAP_Channel_Scale( int mainSub, long x, long y, long w, long h, bool anim )
{
	STAP_Channel_Scale(mainSub, x, y, w, h, anim);
	SENDRECTAP();
	return ATAP_Channel_Scale(mainSub, x, y, w, h, anim);
}

int TAP_Channel_IsPlayable( int mainSub, int svcType, int chNum )
{
	STAP_Channel_IsPlayable(mainSub, svcType, chNum);
	SENDRECTAP();
	return ATAP_Channel_IsPlayable(mainSub, svcType, chNum);
}

int TAP_Channel_Move( int mainSub, int dir )
{
	STAP_Channel_Move(mainSub, dir);
	SENDRECTAP();
	return ATAP_Channel_Move(mainSub, dir);
}

int TAP_Channel_Stop( int mainSub )
{
	STAP_Channel_Stop(mainSub);
	SENDRECTAP();
	return ATAP_Channel_Stop(mainSub);
}

int TAP_Channel_GetTotalAudioTrack( void )
{
	STAP_Channel_GetTotalAudioTrack();
	SENDRECTAP();
	return ATAP_Channel_GetTotalAudioTrack();
}

char *TAP_Channel_GetAudioTrackName( int trkNum, char *trkName )
{
	STAP_Channel_GetAudioTrackName(trkNum, trkName);
	SENDRECTAP();
	return ATAP_Channel_GetAudioTrackName(trkNum, trkName);
}

int TAP_Channel_SetAudioTrack( int trkNum )
{
	STAP_Channel_SetAudioTrack(trkNum);
	SENDRECTAP();
	return ATAP_Channel_SetAudioTrack(trkNum);
}

int TAP_Channel_GetTotalSubtitleTrack( void )
{
	STAP_Channel_GetTotalSubtitleTrack();
	SENDRECTAP();
	return ATAP_Channel_GetTotalSubtitleTrack();
}

char *TAP_Channel_GetSubtitleTrackName( int trkNum, char *trkName )
{
	STAP_Channel_GetSubtitleTrackName(trkNum, trkName);
	SENDRECTAP();
	return ATAP_Channel_GetSubtitleTrackName(trkNum, trkName);
}

int TAP_Channel_SetSubtitleTrack( int trkNum )
{
	STAP_Channel_SetSubtitleTrack(trkNum);
	SENDRECTAP();
	return ATAP_Channel_SetSubtitleTrack(trkNum);
}


TYPE_TapEvent*	TAP_GetEvent( int svcType, int svcNum, int *eventNum )
{
	STAP_GetEvent(svcType, svcNum, eventNum);
	SENDRECTAP();
	return ATAP_GetEvent(svcType, svcNum, eventNum);
}

TYPE_TapEvent*	TAP_GetCurrentEvent( int svcType, int svcNum )
{
	STAP_GetCurrentEvent(svcType, svcNum);
	SENDRECTAP();
	return ATAP_GetCurrentEvent(svcType, svcNum);
}



/*

// --- USB FUNCTIONS ---------------------------------------------------

void TAP_Usb_Read( CHAR *pBuff, WORD size, void (*pFunc)(WORD size) );
void TAP_Usb_Write( CHAR *pBuff, WORD size, void (*pFunc)(WORD size) );
void TAP_Usb_PacketRead( CHAR *pBuff, WORD size, WORD (*pFunc)(WORD size) );
void TAP_Usb_PacketWrite( CHAR *pBuff, WORD size, void (*pFunc)(WORD size), LONG cmd );
void TAP_Usb_Cancel(void);
*/

// --- TIMER FUNCTIONS ---------------------------------------------------

int  TAP_Timer_GetTotalNum( void )
{
	STAP_Timer_GetTotalNum();
	SENDRECTAP();
	return ATAP_Timer_GetTotalNum();
}

bool TAP_Timer_GetInfo( int entryNum, TYPE_TimerInfo *info )
{
	STAP_Timer_GetInfo(entryNum, info);
	SENDRECTAP();
	return ATAP_Timer_GetInfo(entryNum, info);
}

int TAP_Timer_Add( TYPE_TimerInfo *info )
{
	STAP_Timer_Add(info);
	SENDRECTAP();
	return ATAP_Timer_Add(info);
}

int TAP_Timer_Modify( int entryNum, TYPE_TimerInfo *info )
{
	STAP_Timer_Modify(entryNum, info);
	SENDRECTAP();
	return ATAP_Timer_Modify(entryNum, info);
}

bool TAP_Timer_Delete( int entryNum )
{
	STAP_Timer_Delete(entryNum);
	SENDRECTAP();
	return ATAP_Timer_Delete(entryNum);
}


// ---------------------------------------------------------------------
